/*
 *	PiDig - Version 1.2d von Joachim Podlech
 *	Details siehe http://www.digit-digger.purespace.de
 *	Beendet  02. 06. 2000
 *
 *	Berechnung der Zahl Pi nach dem Borwein-Algorithmus 4.ter Ordnung
 *	oder nach dem Gauss'schen AGM Algorithmus
 *	Formatierte Ausgabe auf Bildschirm und in File outform.txt
 *	Ausgabe ohne Formatierung in outplain.txt
 *	Solange weniger als 64k Stellen berechnet werden, ist Vergleich mit Referenz pi.txt mglich;
 *	Angabe der Anzahl falscher Stellen (von hinten)
 *	VORSICHT: Funktioniert erst ab 512 Stellen!
 */

/*
 *	Zeitnahme, Filehandling, Mathematik, malloc
 */

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*
 *	Vereinfachungen ber den Preprozessor
 */

#define SHORT	short unsigned int
#define LONG	long unsigned int
#define PI		3.141592653589793
#define stop	while(1);
#define warte	for (sch = 0; sch <= 250000000; ++sch);
#define warte1	for (sch = 0; sch <= 25000000; ++sch);
#define warte2	for (sch = 0; sch <= 2500000; ++sch);
#define nz		printf("\n");
#define	wae		sch = 1; while (sch == 1) scanf("%u6%*c\n", &sch);

/*
 *	Prototypen
 */

int  addier				(SHORT *a, SHORT *b, SHORT *c, long i, long j, long k);
int  subtrahier			(SHORT *a, SHORT *b, SHORT *c, long i, long j, long k);
void einsminusx			(SHORT *a, SHORT *b, long i);
void nullfuenfminusx	(SHORT *a, SHORT *b, long i);
void mult				(SHORT *a, SHORT *b, SHORT *c, SHORT d);
void multnoch			(SHORT *a, SHORT *b, SHORT *c, SHORT d);
void quadrat			(SHORT *a, SHORT *b, SHORT c);
void ffthinbackup		(double *r1, double *i1, SHORT cache);
void ffthin				(double *a, double *b, SHORT i);
void fftrueck			(double *a, double *b);
void multkurz			(SHORT *a, SHORT *b, SHORT *c, SHORT d, LONG i);
void quadratkurz		(SHORT *a, SHORT *b, SHORT c, LONG i);
void fftkurzhin			(double *r1, double *i1, SHORT i, short int j, unsigned long k);
void fftkurzrueck		(double *r1, double *i1, SHORT i, short int j, unsigned long k);
void karatsuba			(SHORT *a, SHORT *b, SHORT *c, LONG i);
void kmult				(SHORT *a, SHORT *b, SHORT *c, int i);
void multsehrkurz		(SHORT *a, SHORT *b, int i, SHORT *c);
void multganz			(SHORT *a, int i, SHORT *b);
void kehrwert			(SHORT *a, SHORT *b, int i);
void dividier			(SHORT *a, SHORT *b, SHORT *, int i);
void durchzwei			(SHORT *a, SHORT *b, long i);
void durchvier			(SHORT *a, SHORT *b, long i, long j);
void wurzel				(SHORT *a, SHORT *b, SHORT i, long j);
void kubikwurzel		(SHORT *a, SHORT *b, SHORT i);
void wurzel2			(SHORT *a, SHORT i);
void zuweis				(SHORT *a, SHORT *b, long i);
void setznull			(SHORT *a);
LONG fuehrendenullen	(SHORT *a, long i, long j);
LONG zweikommanullen	(SHORT *zahl, long i);
LONG fuehrendeneunen	(SHORT *zahl, long i);
LONG nullenamende		(SHORT *a);
SHORT bas2log			(LONG i);
LONG basis				(LONG i);
void bitswap			(void);
LONG  bs2				(LONG i);
LONG  bs4				(LONG i);
void trigcalc			(void);
LONG eingabe			();
void pformat			(char *a);
void infileplain		(SHORT *a);
SHORT infileformat		(double);
void einles				(char *a);
LONG vergleich			();
void pzahl				(SHORT *a, SHORT b, SHORT c, LONG d, LONG e);
void uform				(LONG a, SHORT b, SHORT c);
void pcomplex			(double *a, double *b, int i);
void fft4				(double *a, double *b, short i, long j);
void m4					(SHORT *a, SHORT *b, SHORT *c);


/*
 *	Externes Array fr trigonometrische Werte, fr bit-swapping
 *	und fr fft-caching, Zeitnahme, korrekte Stellen
 */

double	*ta, *prz, *piz, *merkr, *merki, *r1, *i1, *r2, *i2;
LONG	*ba, stellen0, stellen, gstellen, stellen2, vgl, sch;
SHORT	formel = 0, sz1 = 0, sz2 = 0, log2s, log2s2;
SHORT	*x, *zhl2, *store;

void main(void)

{
	SHORT	*pa, *pb, *pc, *pp, *py;
	SHORT	*n, *m;
	SHORT	iter, abbruch = 0;
	char	*print;
	int		i, l;
	double	time1 = (double)clock();
	double	zeit;

/*
 *	Berechnung auf stellen - 1 Stellen	(stellen - 1: Potenz von 2)
 *	stellen2 fr Multiplikation			(stellen2: (stellen - 1) * 2)
 *	stellen0 fr cos-Berechnungen		(((stellen - 1) / 2) + 1)
 */

	gstellen = eingabe();
	stellen  = gstellen + 1;
	stellen2 = gstellen << 1;
	stellen0 = (gstellen >> 1) + 1;
	log2s    = bas2log(gstellen);
	log2s2   = bas2log(stellen2);

	time1 = (double)clock();
	time1 = time1 / (double)CLOCKS_PER_SEC;

	ba    = (LONG *)   calloc(stellen2 * sizeof(LONG), 1);
	ta    = (double *) malloc(stellen  * sizeof(double));

	bitswap();
	trigcalc();

	prz   = (double *) malloc(stellen2 * sizeof(double));
	piz   = (double *) malloc(stellen2 * sizeof(double));
	merkr = (double *) malloc(stellen2 * sizeof(double));
	merki = (double *) malloc(stellen2 * sizeof(double));
	r1    = (double *) malloc(stellen2 * sizeof(double));
	i1    = (double *) malloc(stellen2 * sizeof(double));
	r2    = (double *) malloc(stellen2 * sizeof(double));
	i2    = (double *) malloc(stellen2 * sizeof(double));

	x     = (SHORT *)  malloc(stellen  * sizeof(SHORT));
	zhl2  = (SHORT *)  malloc(stellen  * sizeof(SHORT));

	if (formel == 9)

/*
 *	Workspace for testing
 */

		{
			m     = (SHORT *) calloc(stellen * sizeof(SHORT), 1);
			n     = (SHORT *) calloc(stellen * sizeof(SHORT), 1);
			py    = (SHORT *) calloc(stellen * sizeof(SHORT), 1);
			pp    = (SHORT *) calloc(stellen * sizeof(SHORT), 1);

	n[0] = 3141;	n[1] = 5926;    n[2] = 5358;    n[3] = 9793; 	n[4] = 2384;    n[5] = 6264;    n[6] = 3383;    n[7] = 2795;
	n[8] = 288;     n[9] = 4197;    n[10] = 1693;   n[11] = 9937;	n[12] = 5105;   n[13] = 8209;   n[14] = 7494;   n[15] = 4592;
/*	n[16] = 3078;   n[17] = 1640;   n[18] = 6286;   n[19] = 2089;	n[20] = 9862;   n[21] = 8034;   n[22] = 8253;   n[23] = 4211;
	n[24] = 7067;   n[25] = 9821;   n[26] = 4808;   n[27] = 6513;	n[28] = 2823;   n[29] = 664;    n[30] = 7093;   n[31] = 8446;
	n[32] = 955;    n[33] = 582;    n[34] = 2317;   n[35] = 2535;	n[36] = 9408;   n[37] = 1284;   n[38] = 8111;   n[39] = 7450;
	n[40] = 2841;   n[41] = 270;    n[42] = 1938;   n[43] = 5211;	n[44] = 555;    n[45] = 9644;   n[46] = 6229;   n[47] = 4895;
	n[48] = 4930;   n[49] = 3819;   n[50] = 6442;   n[51] = 8810;	n[52] = 9756;   n[53] = 6593;   n[54] = 3446;   n[55] = 1284;
	n[56] = 7564;   n[57] = 8233;   n[58] = 7867;   n[59] = 8316;	n[60] = 5271;   n[61] = 2019;   n[62] = 914;    n[63] = 5648;
	n[64] = 5669;   n[65] = 2346;   n[66] = 348;    n[67] = 6104;	n[68] = 5432;   n[69] = 6648;   n[70] = 2133;   n[71] = 9360;
	n[72] = 7260;   n[73] = 2491;   n[74] = 4127;   n[75] = 3724;	n[76] = 5870;   n[77] = 660;    n[78] = 6315;   n[79] = 5881;
	n[80] = 7488;   n[81] = 1520;   n[82] = 9209;   n[83] = 6282;	n[84] = 9254;   n[85] = 917;    n[86] = 1536;   n[87] = 4367;
	n[88] = 8925;   n[89] = 9036;   n[90] = 11;     n[91] = 3305;	n[92] = 3054;   n[93] = 8820;   n[94] = 4665;   n[95] = 2138;
	n[96] = 4146;   n[97] = 9519;   n[98] = 4151;   n[99] = 1609;	n[100] = 4330;  n[101] = 5727;  n[102] = 365;   n[103] = 7595;
	n[104] = 9195;  n[105] = 3092;  n[106] = 1861;  n[107] = 1738;	n[108] = 1932;  n[109] = 6117;  n[110] = 9310;  n[111] = 5118;
	n[112] = 5480;  n[113] = 7446;  n[114] = 2379;  n[115] = 9627;	n[116] = 4956;  n[117] = 7351;  n[118] = 8857;  n[119] = 5272;
	n[120] = 4891;  n[121] = 2279;  n[122] = 3818;  n[123] = 3011;	n[124] = 9491;  n[125] = 2983;  n[126] = 3673;  n[127] = 2220;
	n[128] = 4065;  n[129] = 6643;  n[130] = 860;   n[131] = 2139;	n[132] = 4946;  n[133] = 3952;  n[134] = 2473;  n[135] = 7190;
	n[136] = 7021;  n[137] = 7986;  n[138] = 943;   n[139] = 7027;	n[140] = 7053;  n[141] = 9217;  n[142] = 1762;  n[143] = 9317;
	n[144] = 6752;  n[145] = 3846;  n[146] = 7481;  n[147] = 8467;	n[148] = 6694;  n[149] = 513;   n[150] = 2000;  n[151] = 5681;
	n[152] = 2714;  n[153] = 5263;  n[154] = 5608;  n[155] = 2778;	n[156] = 5771;  n[157] = 3427;  n[158] = 5778;  n[159] = 9609;
	n[160] = 1736;  n[161] = 3717;  n[162] = 8721;  n[163] = 4684;	n[164] = 4090;  n[165] = 1224;  n[166] = 9534;  n[167] = 3014;
	n[168] = 6549;  n[169] = 5853;  n[170] = 7105;  n[171] = 792;	n[172] = 2796;  n[173] = 8925;  n[174] = 8923;  n[175] = 5420;
	n[176] = 1995;  n[177] = 6112;  n[178] = 1290;  n[179] = 2196;	n[180] = 864;   n[181] = 344;   n[182] = 1815;  n[183] = 9813;
	n[184] = 6297;  n[185] = 7477;  n[186] = 1309;  n[187] = 9605;	n[188] = 1870;  n[189] = 7211;  n[190] = 3499;  n[191] = 9999;
	n[192] = 8372;  n[193] = 9780;  n[194] = 4995;  n[195] = 1059;	n[196] = 7317;  n[197] = 3281;  n[198] = 6096;  n[199] = 3185;
	n[200] = 9502;  n[201] = 4459;  n[202] = 4553;  n[203] = 4690;	n[204] = 8302;  n[205] = 6425;  n[206] = 2230;  n[207] = 8253;
	n[208] = 3446;  n[209] = 8503;  n[210] = 5261;  n[211] = 9311;	n[212] = 8817;  n[213] = 1010;  n[214] = 31;    n[215] = 3783;
	n[216] = 8752;  n[217] = 8865;  n[218] = 8753;  n[219] = 3208;	n[220] = 3814;  n[221] = 2061;  n[222] = 7177;  n[223] = 6691;
	n[224] = 4730;  n[225] = 3598;  n[226] = 2534;  n[227] = 9042;	n[228] = 8755;  n[229] = 4687;  n[230] = 3115;  n[231] = 9562;
	n[232] = 8638;  n[233] = 8235;  n[234] = 3787;  n[235] = 5937;	n[236] = 5195;  n[237] = 7781;  n[238] = 8577;  n[239] = 8053;
	n[240] = 2171;  n[241] = 2268;  n[242] = 661;   n[243] = 3001;	n[244] = 9278;  n[245] = 7661;  n[246] = 1195;  n[247] = 9092;
	n[248] = 1642;  n[249] = 198;   n[250] = 9380;  n[251] = 9525;	n[252] = 7201;  n[253] = 654;   n[254] = 8585;  n[255] = 9759;
*/

			mult(n, n, m, 0);

			printf("fertig");

		}
	else if (formel == 1)
		{

/*
 *	Borwein quartic formula
 */

			pa     = (SHORT *) malloc(stellen * sizeof(SHORT));
			pb     = (SHORT *) malloc(stellen * sizeof(SHORT));
			pc     = (SHORT *) malloc(stellen * sizeof(SHORT));
			pp     = (SHORT *) malloc(stellen * sizeof(SHORT));
			py     = (SHORT *) malloc(stellen * sizeof(SHORT));

			iter = (1 / log10(4)) * log10(stellen / 2.675) + 1;

			for (i = 0; i <= iter; ++i)
				printf("+");
			for (i = 0; i <= iter; ++i)
				printf("\b");

			wurzel2(py, 1);
			multganz(py, 4, pc);
			*pc -= 5000;
			einsminusx(pc, pa, stellen);
			multganz(py, 12, pp);
			*pp -= 6000;
			printf("|");
			kubikwurzel(pp, pc, 2);
			zuweis(pb, pc, stellen);
			*pb -= 1000;
			*pc += 1000;
			dividier(pb, pc, py, 0);
			multganz(py, 4, pb);
			*pb += 1000;
			quadrat(py, pp, 1);
			multganz(pp, 6, pc);
			addier(pb, pc, pb, 0, stellen, 0);
			addier(py, pp, pc, 0, stellen, 0);
			mult(pp, py, py, 3);
			addier(pc, py, pc, 0, stellen, 0);
			multganz(py, 4, pp);
			addier(pb, pp, pb, 0, stellen, 0);
			quadrat(py, py, 2);
			addier(pb, py, pb, 0, stellen, 0);
			mult(pb, pa, pa, 0);
			multganz(pc, 8, pp);
			subtrahier(pa, pp, pa, 0, stellen, 0);

			l = 8;

			for (i = 1; i <= iter; ++i)
				{
					printf("|");
					einsminusx(py, pp, stellen);
					kubikwurzel(pp, pc, 2);
					zuweis(pb, pc, stellen);
					*pb -= 1000;
					*pc += 1000;
					dividier(pb, pc, py, 1);
					multganz(py, 4, pb);
					*pb += 1000;
					quadrat(py, pp, 1);
					multganz(pp, 6, pc);
					addier(pb, pc, pb, 0, stellen, 0);
					addier(py, pp, pc, 0, stellen, 0);
					mult(pp, py, py, 3);
					addier(pc, py, pc, 0, stellen, 0);
					multganz(py, 4, pp);
					addier(pb, pp, pb, 0, stellen, 0);
					quadrat(py, py, 2);
					addier(pb, py, pb, 0, stellen, 0);
					mult(pb, pa, pa, 0);
					l <<= 2;
					multganz(pc, l, pp);
					subtrahier(pa, pp, pa, 0, stellen, 0);
				}

			kehrwert(pa, pp, 0);
		}
	else if (formel == 2)
		{

/*
 *	Gauss AGM formula
 */

			pa    = (SHORT *) malloc(stellen * sizeof(SHORT));
			pb    = (SHORT *) malloc(stellen * sizeof(SHORT));
			pc    = (SHORT *) malloc(stellen * sizeof(SHORT));
			pp    = (SHORT *) malloc(stellen * sizeof(SHORT));
			py    = (SHORT *) malloc(stellen * sizeof(SHORT));
			store = (SHORT *) malloc(stellen * sizeof(SHORT));

			iter = (1 / log10(2)) * log10(stellen2);

			printf("Approximately %d passes have to be done\n", iter + 1);

			for (i = 0; i <= iter + 1; ++i)
				printf("+");
			for (i = 0; i <= iter + 1; ++i)
				printf("\b");

			wurzel2(py, 2);

			l = 0;
			i = 2;

			printf("|");
			*py += 1000;
			durchzwei(py, pa, stellen);
			*py -= 1000;
			quadrat(pa, pc, 0);
			subtrahier(pc, py, pc, 0, stellen, 0);
			wurzel(py, pb, 0, 8);
			multganz(pc, 4, pp);
			einsminusx(pp, pc, stellen);

			while (abbruch < 2)
				{
					if (abbruch == 1)
						abbruch = 2;

					printf("|");
					addier(pa, pb, pp, 0, stellen, 0);

					if (abbruch == 0)
						mult(pa, pb, py, 0);

					durchzwei(pp, pa, stellen);
					quadrat(pa, pb, 0);

					if (abbruch == 0)
						{
							subtrahier(pb, py, pp, 0, stellen, 0);
							l = fuehrendenullen(pp, l, stellen);

							if (l > stellen0)
								abbruch = 1;
						}

					if (abbruch < 2)
						{
							if (i > 5)
								wurzel(py, pb, 1, pow(2, (i - 1)));
							else
								wurzel(py, pb, 0, 8);

							multganz(pp, pow(2, (i + 1)), py);
							subtrahier(pc, py, pc, 0, stellen, 0);
							++i;
						}
				}

			printf("<");
			multganz(pb, 4, py);
			dividier(py, pc, pp, 0);
		}
	else if (formel == 3)
		{

/*
 *	Gauss AGM formula modified by Carey Bloodworth
 */

		}
	else if (formel == 8)
		{

/*
 *	Squareroot of 2 for testing
 */

			pp     = (SHORT *) malloc(stellen * sizeof(SHORT));

			wurzel2(pp, 1);
		}

	zeit = (((double)clock()) / (double)CLOCKS_PER_SEC) - time1;

	if (formel != 8)
		for (i = 0; i <= iter; ++i)
			printf("\b");

	infileplain(pp);

	vgl = vergleich();

	infileformat(zeit);
	print = (char *) malloc((stellen2 * 2) * sizeof(char));
	einles(print);
	pformat(print);

	if ((stellen < 250000) && (vgl != 0))
		printf("The last %d digits are wrong\n", (2 * stellen2) - vgl);
	printf("Elapsed time: %.2f seconds (without storing)\n",zeit);
	stop
}

int addier(SHORT *s1, SHORT *s2, SHORT *summe, long anfang, long ende, long versatz)

/*
 *	Addiert zwei Zahlen und gibt die Summe zurck und gibt den bertrag zurck.
 *	Addiert nur den Teil zwischen anfang und ende
 *	Wenn eine kurzere Zahl zum Mittelteil einer lngeren Zahl addiert werden soll,
 *	dann sollte der Versatz != 0 angegeben werden. Der Versatz wird als negativ angenommen
 *	Falls nicht die komplette Addition durchgefhrt wird, sollte s1 = summe sein
 *		Eingabe:  *s1, *s2
 *		Rckgabe: *summe (Die Rckgabe in einen Summanden ist mglich)
 */

 {
	int		zwischensumme;
	SHORT	uebertrag = 0;
	long	i;

	for (i = ende - 2; i >= anfang; --i)
		{
			zwischensumme = *(s1 + i) + *(s2 + i - versatz) + uebertrag;
			uebertrag = 0;

			if (zwischensumme > 9999)
				{
					zwischensumme -= 10000;
					uebertrag = 1;
				}

			*(summe + i) = zwischensumme;
		}

	while ((uebertrag == 1) && (i >= 0))
		{
			zwischensumme = *(s1  + i) + uebertrag;
			uebertrag = 0;

			if (zwischensumme > 9999)
				{
					zwischensumme -= 10000;
					uebertrag = 1;
				}

			*(summe + i) = zwischensumme;
			--i;
		}

	return(uebertrag);
}

int subtrahier(SHORT *s1, SHORT *s2, SHORT *summe, long anfang, long ende, long versatz)

/*
 *	Subtrahiert zwei Zahlen und gibt den bertrag zurck
 *	Subtrahiert nur den Teil zwischen anfang und ende
 *	Wenn eine kurzere Zahl vom Mittelteil einer lngeren Zahl subtrahiert werden soll,
 *	dann sollte der Versatz != 0 angegeben werden. Der Versatz wird als negativ angenommen
 *	Falls nicht die komplette Subtraktion durchgefhrt wird, sollte s1 = summe sein
 *		Eingabe:  *s1, *s2
 *		Rckgabe: *summe (Die Rckgabe in einen Summanden ist mglich)
 *	Funktionswert abhngig davon, ob s1 = s2 (2), s1 < s2 (1) oder s1 > s2 (0)
 *		Bei Bedarf berprfen
 */

{
	int		zwischensumme;
	SHORT	uebertrag = 0, gleich = 1;
	long	i;

	for (i = ende - 2; i >= anfang; --i)
		{
			zwischensumme = *(s1 + i) - *(s2 + i - versatz) - uebertrag;
			uebertrag = 0;

			if (zwischensumme < 0)
				{
					zwischensumme += 10000;
					uebertrag = 1;
					gleich = 0;
				}
			else if (zwischensumme > 0)
				gleich = 0;

			*(summe + i) = zwischensumme;
		}

	while ((uebertrag == 1) && (i >= 0))
		{
			zwischensumme = *(s1  + i) - uebertrag;
			uebertrag = 0;

			if (zwischensumme < 0)
				{
					zwischensumme += 10000;
					uebertrag = 1;
				}

			*(summe + i) = zwischensumme;
			--i;
		}

	if (gleich == 1)
		uebertrag = 2;

	return(uebertrag);
}

void einsminusx(SHORT *zahl, SHORT *produkt, long ende)

/*
 *	Subtrahiert eine Zahl von 1
 *	Zahl darf zwar maximal 1 sein! Sollte es aber eigentlich vom Programmverlauf her nicht sein
 */

{
	int 	zwischensumme;
	SHORT	uebertrag = 0;
	long	i;

	if (*zahl == 1000)
		{
			setznull(produkt);

			return;
		}

	for (i = ende - 2; i >= 0; --i)
		{
			zwischensumme = *(zahl + i) + uebertrag;
			uebertrag = 0;

			if (zwischensumme != 0)
				{
					zwischensumme = 10000 - zwischensumme;
					uebertrag = 1;
				}

			*(produkt + i) = zwischensumme;
		}

	*produkt %= 1000;

	return;
}

void nullfuenfminusx(SHORT *zahl, SHORT *produkt, long ende)

/*
 *	Subtrahiert eine Zahl von 0.5
 *	Zahl darf maximal 0.5 sein! Sollte es aber wiederum nicht sein
 */

{
	int		zwischensumme, uebertrag = 0;
	long	i;

	if (*zahl == 500)
		{
			setznull(produkt);

			return;
		}

	for (i = ende - 2; i >= 1; --i)
		{
			zwischensumme = *(zahl + i) + uebertrag;
			uebertrag = 0;

			if (zwischensumme != 0)
				{
					zwischensumme = 10000 - zwischensumme;
					uebertrag = 1;
				}

			*(produkt + i) = zwischensumme;
		}

	*produkt = 500 - *zahl - uebertrag;

	return;
}

void mult(SHORT *z1, SHORT *z2, SHORT *produkt, SHORT cache)

/*
 *	fft-Multiplikation; Nicht rekursiv
 *		Eingabe:  *z1, *z2
 *		Rckgabe: *produkt (Die Rckgabe in Multiplikant oder Multiplikator ist mglich)
 *		Wenn cache = 0: Normale Multiplikation
 *				   = 1: 1. Wert wird als fft im cache (merk) abgelegt
 *				   = 2: 2. Wert liegt im cache vor und wird eingelesen
 *				   = 3; 1. Wert wird im cache abgelegt; 2. Wert wird eingelesen
 */

{
	double			zreal, zimag, ue;
	long			n, ln, i, index;
	unsigned long	uebertrag = 0;

	 n = gstellen;
	ln = stellen2;

	for (i = 0; i <= ln - 1; ++i)
			*(i1 + i) = 0;

	if (cache < 2)
		for (i = 0; i <= ln - 1; ++i)
			*(i2 + i) = 0;

	if (cache < 2)
		for (i = 0; i <= ln - 1; i += 2)
			{
				*(r1 + i)         = *(z1 + (index = ba[i]));
				*(r1 + i + 1)     = *(z1 + index);
				*(r2 + i)         = *(z2 + index);
				*(r2 + i + 1)     = *(z2 + index);
			}
	else if (cache == 2)
		for (i = 0; i <= ln - 1; i += 2)
			{
				index = ba[i];
				*(r1 + i)     = *(z1 + index);
				*(r1 + i + 1) = *(z1 + index);
			}
	else
		{
			for (i = 0; i <= ln - 1; i += 2)
				{
					index = ba[i];
					*(r1 + i)     = *(z1 + index);
					*(r1 + i + 1) = *(z1 + index);
				}

			for (i = 0; i <= ln - 1; ++i)
				{
					*(r2 + i) = *(merkr + i);
					*(i2 + i) = *(merki + i);
				}
		}

	ffthin(r1, i1, cache);

	if (cache < 2)
		ffthin(r2, i2, 0);

	if ((cache == 1) || (cache == 3))
		for (i = 0; i <= ln - 1; ++i)
			{
				zreal = (*(merkr + i) * *(r2 + i)) - (*(merki + i) * *(i2 + i));
				zimag = (*(merkr + i) * *(i2 + i)) + (*(r2 + i) * *(merki + i));
				*(r2 + i) = zreal;
				*(i2 + i) = zimag;
			}
	else if (cache == 2)
		for (i = 0; i <= ln - 1; ++i)
			{
				zreal = (*(r1 + i) * *(merkr + i)) - (*(i1 + i) * *(merki + i));
				zimag = (*(r1 + i) * *(merki + i)) + (*(merkr + i) * *(i1 + i));
				*(r2 + i) = zreal;
				*(i2 + i) = zimag;
			}
	else
		for (i = 0; i <= ln - 1; ++i)
			{
				zreal = (*(r1 + i) * *(r2 + i)) - (*(i1 + i) * *(i2 + i));
				zimag = (*(r1 + i) * *(i2 + i)) + (*(r2 + i) * *(i1 + i));
				*(r2 + i) = zreal;
				*(i2 + i) = zimag;
			}

	for (i = 0; i <= ln - 1; ++i)
		if ((index = ba[i]) > i)
			{
				*(r1 + i)     = *(r2 + index);
				*(i1 + i)     = *(i2 + index);
				*(r1 + index) = *(r2 + i);
				*(i1 + index) = *(i2 + i);
			}
		else if (index == i)
			{
				*(r1 + i) = *(r2 + i);
				*(i1 + i) = *(i2 + i);
			}

	fftrueck(r1, i1);

/*
 *	Hier wird die kompliziertere bertrags-Auflsung
 *	durch eine Multiplikation mit 10 erreicht
 */

	for (i = n + 3; i >= n - 1; --i)
		{
			ue            = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag     = ue * 0.0001;
		}

	if ((ue - ((double) uebertrag * 10000)) >= 5000)
		++uebertrag;

	for (i = n - 2; i >= 0; --i)
		{
			ue                 = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag          = ue * 0.0001;
			*(produkt + i + 1) = ue - ((double) uebertrag * 10000);
		}

	*produkt = uebertrag;

	return;
}

void quadrat(SHORT *z1, SHORT *produkt, SHORT cache)

/*
 *	fft-Multiplikation; Das ganze Drumrum
 *		Eingabe:  *z1
 *		Rckgabe: *produkt (Die Rckgabe in Multiplikant oder Multiplikator ist mglich)
 *		Wenn cache = 0: Normale Multiplikation
 *				   = 1: Wert wird als fft im cache (merk) abgelegt
 *				   = 2: Wert liegt im cache vor und wird eingelesen
 *				   = 3: Kommt wohl nicht vor!! Wre berflssig, da sich merk nicht ndert
 */

{
	double			zreal, zimag, ue;
	long			n, ln, i, index;
	unsigned long	uebertrag = 0;

	 n = gstellen;
	ln = stellen2;

	if (cache < 2)
		for (i = 0; i <= ln - 1; ++i)
			*(i1 + i) = 0;

	if (cache < 2)
		{
			for (i = 0; i <= ln - 1; i += 2)
				{
					index = ba[i];
					*(r1 + i)     = *(z1 + index);
					*(r1 + i + 1) = *(z1 + index);
				}

			ffthin(r1, i1, cache);
		}

	if (cache > 0)
		for (i = 0; i <= ln - 1; ++i)
			{
				zreal = (*(merkr + i) * *(merkr + i)) - (*(merki + i) * *(merki + i));
				zimag = 2 * *(merkr + i) * *(merki + i);
				*(r1 + i) = zreal;
				*(i1 + i) = zimag;
			}
	else
		for (i = 0; i <= ln - 1; ++i)
			{
				zreal = (*(r1 + i) * *(r1 + i)) - (*(i1 + i) * *(i1 + i));
				zimag = 2 * *(r1 + i) * *(i1 + i);
				*(r1 + i) = zreal;
				*(i1 + i) = zimag;
			}

	for (i = 0; i <= ln - 1; ++i)
		if ((index = ba[i]) > i)
			{
				zreal         = *(r1 + index);
				zimag         = *(i1 + index);
				*(r1 + index) = *(r1 + i);
				*(i1 + index) = *(i1 + i);
				*(r1 + i)     = zreal;
				*(i1 + i)     = zimag;
			}

	fftrueck(r1, i1);

/*
 *	Hier wird die kompliziertere bertrags-Auflsung
 *	durch eine Multiplikation mit 10 erreicht
 */

	for (i = n + 3; i >= n - 1; --i)
		{
			ue            = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag     = ue * 0.0001;
		}

	if ((ue - ((double) uebertrag * 10000)) >= 5000)
		++uebertrag;

	for (i = n - 2; i >= 0; --i)
		{
			ue                 = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag          = ue * 0.0001;
			*(produkt + i + 1) = ue - ((double) uebertrag * 10000);
		}

	*produkt = uebertrag;

	return;
}

void multnoch(SHORT *z1, SHORT *z2, SHORT *produkt, SHORT cache)

{
	long			n, ln, i;
	unsigned long	uebertrag = 0;

	 n = gstellen;
	ln = stellen2;

	for (i = 0; i <= n - 1; ++i)
		{
			*(r1 + i) = *(z1 + i);
			*(i1 + i) = 0;
		}

	for (i = n; i <= ln - 1; ++i)
			*(i1 + i) = *(r1 + i) = 0;

	ffthin(r1, i1, cache);

	return;
}

void ffthinbackup(double *r1, double *i1, SHORT cache)

/*
 *	Nicht-rekursive Fast Fourier Transformation
 *	Hin
 */

{
	double	trt, tit,
			ur, vr, vi,
			argument;
	long	ln, n, i, ir, im, j, m, mh;

	ln = stellen2;

/*
 *	Zweitunterste Ebene der Faltung; n = 2
 */

	for (j = 0; j <= ln - 4; j += 4)
		{
			*(i1 + j + 1) = -(*(i1 + j + 3) = *(r1 + j + 3));
			*(r1 + j)     =   *(r1 + j + 1) + *(i1 + j + 3);
			*(r1 + j + 2) =   *(r1 + j + 1) + *(i1 + j + 1);
			*(r1 + j + 3) =   *(r1 + j + 1);
		}

/*
 *	Drittunterste Ebene der Faltung; n = 3
 */

	for (j = 0; j <= (ln >> 3) - 1; ++j)
		{
/**/			ir = 5 + (m = j * 8);
/**/			im = 1 + m;
			tit =  0.707106781186548;
			trt = -0.707106781186548;


			*(r1 + 7 + m) =   *(r1 + im) + *(r1 + ir) * tit - *(i1 + ir) * trt;
			*(i1 + 7 + m) = -(*(i1 + im) + *(i1 + ir) * tit + *(r1 + ir) * trt);
	 		*(r1 + 3 + m) =   *(r1 + im) - *(r1 + ir) * tit + *(i1 + ir) * trt;
			*(i1 + 3 + m) = -(*(i1 + im) - *(i1 + ir) * tit - *(r1 + ir) * trt);
			*(r1 + im) =   *(r1 + 7 + m);
			*(i1 + im) = -(*(i1 + 7 + m));
			*(r1 + ir) =   *(r1 + 3 + m);
			*(i1 + ir) = -(*(i1 + 3 + m));
			*(i1 + 2 + m) = -(*(i1 + 6 + m) = *(r1 + 6 + m));
			*(r1 + 6 + m) =   *(r1 + 2 + m);

			ur = *(r1 + m);
			*(r1 + m)    +=      *(r1 + 4 + m);
	 		*(r1 + 4 + m) = ur - *(r1 + 4 + m);
		}

/*
 *	Restliche Ebenen der Faltung; n = 4 bis log2(ln)
 */

	for (n = 4; n <= log2s2; ++n)
		{
			m  = (mh = 1 << (n - 1)) << 1;

			for (i = 0; i <= ln - 1; i += m)
				{
					ur = *(r1 + i);

					*(r1 + i) += *(r1 + (im = i + mh));
					*(r1 + im) = ur - *(r1 + im);
				}

			for (j = 1; j <= mh - 1; ++j)
				{
					trt =  cos(argument = (PI * j / (m >> 1)));
					tit = -sin(argument);

					for (i = 0; i <= ln - 1; i += m)
						{
							im = (ir = i + j) + mh;
							vr = *(r1 + im) * trt - *(i1 + im) * tit;
							vi = *(i1 + im) * trt + *(r1 + im) * tit;

							*(r1 + im) = *(r1 + ir) - vr;
							*(i1 + im) = *(i1 + ir) - vi;
							*(r1 + ir) += vr;
							*(i1 + ir) += vi;
						}
				}
		}

	if ((cache == 1) || (cache == 3))
		for (i = 0; i <= stellen2 - 1; ++i)
			{
				*(merkr + i) = *(r1 + i);
				*(merki + i) = *(i1 + i);
			}
	return;
}

void ffthin(double *r1, double *i1, SHORT cache)

/*
 *	Nicht-rekursive Fast Fourier Transformation
 *	Hin
 *	Die Zahl wird "geswapt" eingelesen und dann zurckgefaltet
 *	n = 1 entfllt wegen angepasster Manipulation in mult
 */

{
	double	k1, l1;
	long	n, ln, ln2, i, j, m, m1, n1, n2;
	SHORT	log2n, diff;

	n2 = gstellen;
	ln = gstellen << 1;

/*
 *	Zweitunterste Ebene der Faltung; n = 2
 */

	for (j = 0; j <= (ln - 4); j += 4)
		{
			*(prz + j)     =                    *(r1 + j) + *(r1 + j + 2);
			*(piz + j + 2) =   *(piz + j)     = 0;
			*(prz + j + 3) =   *(prz + j + 1) = *(r1 + j + 1) + *(i1 + j + 3);
			*(piz + j + 3) = -(*(piz + j + 1) = *(i1 + j + 1) - *(r1 + j + 3));
			*(prz + j + 2) =                    *(r1 + j) - *(r1 + j + 2);
		}

/*
 *	Drittunterste Faltungsebene; n = 4
 */

	for (j = 0; j <= (ln >> 3) - 1; ++j)
		{
			m = j << 3;
			*(r1 + m)     = *(prz + m) + *(prz + 4 + m);
	 		*(r1 + 4 + m) = *(prz + m) - *(prz + 4 + m);

			k1 =  0.707106781186548;
			l1 = -0.707106781186548;
			*(r1 + 7 + m) =   *(r1 + 1 + m) = *(prz + 1 + m) + *(prz + 5 + m) * k1 - *(piz + 5 + m) * l1;
			*(i1 + 7 + m) = -(*(i1 + 1 + m) = *(piz + 1 + m) + *(piz + 5 + m) * k1 + *(prz + 5 + m) * l1);
	 		*(r1 + 3 + m) =   *(r1 + 5 + m) = *(prz + 1 + m) - *(prz + 5 + m) * k1 + *(piz + 5 + m) * l1;
			*(i1 + 3 + m) = -(*(i1 + 5 + m) = *(piz + 1 + m) - *(piz + 5 + m) * k1 - *(prz + 5 + m) * l1);
			*(r1 + 6 + m) =   *(r1 + 2 + m) = *(prz + 2 + m);
			*(i1 + 2 + m) = -(*(i1 + 6 + m) = *(prz + 6 + m));
		}

/*
 *	Restliche Faltungsebenen; "n = 8 bis n = ln / 2"
 */

	if ((log2s & 1) == 0)
		ln2 = ln;
	else
		ln2 = ln >> 1;

/*
 *	z. B. Eingabe 4k
 */

	log2n = 3;

	for (n = 8; n <= ln2 >> 1; n <<= 1, ++log2n)
		{
			diff = log2s - log2n;

			for (j = 0; j <= (ln >> (log2n + 1)) - 1; ++ j)
				{
					m = j << (log2n + 1);
					l1 = *(i1 + (n1 = n + m)) * ta[gstellen >> 1];
					*(prz + m)  = *(r1 + m) + *(r1 + n1) - l1;
					*(prz + n1) = *(r1 + m) - *(r1 + n1) + l1;

					for (i = 1; i <= n >> 1; ++i)
						{
							m1 = i + m;
							n1 = n + m1;
							k1 = ta[i << diff];
							l1 = ta[((n >> 1) + i) << diff];
							*(prz + m1) = *(r1 + m1) + *(r1 + n1) * k1 - *(i1 + n1) * l1;
							*(piz + m1) = *(i1 + m1) + *(i1 + n1) * k1 + *(r1 + n1) * l1;
					 		*(prz + n1) = *(r1 + m1) - *(r1 + n1) * k1 + *(i1 + n1) * l1;
	 						*(piz + n1) = *(i1 + m1) - *(i1 + n1) * k1 - *(r1 + n1) * l1;
						}

					for (i = (n + 2) >> 1; i <= n - 1; ++i)
						{
							k1 = ta[i << diff];
							l1 = ta[(i - (n >> 1)) << diff];
							m1 = i + m;
							n1 = n + m1;
							*(prz + m1) = *(r1 + m1) + *(r1 + n1) * k1 + *(i1 + n1) * l1;
							*(piz + m1) = *(i1 + m1) + *(i1 + n1) * k1 - *(r1 + n1) * l1;
							*(prz + n1) = *(r1 + m1) - *(r1 + n1) * k1 - *(i1 + n1) * l1;
							*(piz + n1) = *(i1 + m1) - *(i1 + n1) * k1 + *(r1 + n1) * l1;
						}
				}

			n <<= 1;
			++log2n;
			--diff;

			for (j = 0; j <= (ln >> (log2n + 1)) - 1; ++ j)
				{
					m = j << (log2n + 1);
					l1 = *(piz + (n1 = n + m)) * ta[gstellen >> 1];
					*(r1 + m)  = *(prz + m) + *(prz + n1) - l1;
					*(r1 + n1) = *(prz + m) - *(prz + n1) + l1;

					for (i = 1; i <= n >> 1; ++i)
						{
			 				k1 = ta[i << diff];
	 						l1 = ta[((n >> 1) + i) << diff];
							m1 = i + m;
							n1 = n + m1;
							*(r1 + m1) = *(prz + m1) + *(prz + n1) * k1 - *(piz + n1) * l1;
							*(i1 + m1) = *(piz + m1) + *(piz + n1) * k1 + *(prz + n1) * l1;
					 		*(r1 + n1) = *(prz + m1) - *(prz + n1) * k1 + *(piz + n1) * l1;
	 						*(i1 + n1) = *(piz + m1) - *(piz + n1) * k1 - *(prz + n1) * l1;
						}

					for (i = (n + 2) >> 1; i <= n - 1; ++i)
						{
							k1 = ta[i << diff];
	 						l1 = ta[(i - (n >> 1)) << diff];
							m1 = i + m;
							n1 = n + m1;
							*(r1 + m1) = *(prz + m1) + *(prz + n1) * k1 + *(piz + n1) * l1;
							*(i1 + m1) = *(piz + m1) + *(piz + n1) * k1 - *(prz + n1) * l1;
							*(r1 + n1) = *(prz + m1) - *(prz + n1) * k1 - *(piz + n1) * l1;
							*(i1 + n1) = *(piz + m1) - *(piz + n1) * k1 + *(prz + n1) * l1;
						}
				}
		}

	if (ln2 == (ln >> 1))
		{

/*
 *	z. B. Eingabe 8k
 */

			n = ln >> 1;
			log2n = log2s;

			for (j = 0; j <= (ln >> (log2n + 1)) - 1; ++ j)
				{
					l1 = *(i1 + (n1 = n + (m = j << (log2n + 1)))) * ta[gstellen >> 1];
					*(prz + m)  = *(r1 + m) + *(r1 + n1) - l1;
					*(prz + n1) = *(r1 + m) - *(r1 + n1) + l1;

					for (i = 1; i <= n >> 1; ++i)
						{
			 				k1 = ta[i];
	 						l1 = ta[((n >> 1) + i)];
							n1 = n + (m1 = i + m);
							*(prz + m1) = *(r1 + m1) + *(r1 + n1) * k1 - *(i1 + n1) * l1;
							*(piz + m1) = *(i1 + m1) + *(i1 + n1) * k1 + *(r1 + n1) * l1;
					 		*(prz + n1) = *(r1 + m1) - *(r1 + n1) * k1 + *(i1 + n1) * l1;
	 						*(piz + n1) = *(i1 + m1) - *(i1 + n1) * k1 - *(r1 + n1) * l1;
						}

					for (i = (n + 2) >> 1; i <= n - 1; ++i)
						{
							k1 = ta[i];
	 						l1 = ta[(i - (n >> 1))];
							n1 = n + (m1 = i + m);
							*(prz + m1) = *(r1 + m1) + *(r1 + n1) * k1 + *(i1 + n1) * l1;
							*(piz + m1) = *(i1 + m1) + *(i1 + n1) * k1 - *(r1 + n1) * l1;
							*(prz + n1) = *(r1 + m1) - *(r1 + n1) * k1 - *(i1 + n1) * l1;
							*(piz + n1) = *(i1 + m1) - *(i1 + n1) * k1 + *(r1 + n1) * l1;
						}
				}

			if ((cache == 1) || (cache == 3))
				for (i = 0; i <= ln - 1; ++i)
					{
						*(merkr + i) = *(prz + i);
						*(merki + i) = *(piz + i);
					}
			else
				for (i = 0; i <= ln - 1; ++i)
					{
						*(r1 + i) = *(prz + i);
						*(i1 + i) = *(piz + i);
					}
		}
	else
		if ((cache == 1) || (cache == 3))
			for (i = 0; i <= ln - 1; ++i)
				{
					*(merkr + i) = *(r1 + i);
					*(merki + i) = *(i1 + i);
				}

	return;
}

void fftrueck(double *r1, double *i1)

/*
 *	Nicht-rekursive Fast Fourier Transformation
 *	Rck
 *	Die Zahl wird "geswapt" eingelesen und dann zurckgefaltet
 */

{
	double	k1, l1;
	long	n, ln, ln2, i, j, m, m1, n1, n2;
	SHORT	log2n, diff;

	n2 = gstellen;
	ln = gstellen << 1;

/*
 *	Unterste Ebene der Faltung; "n = 1"
 */

	for (j = 0; j <= (ln - 2); j += 2)
		{
			*(prz + j)     = *(r1 + j) + *(r1 + j + 1);
			*(prz + j + 1) = *(r1 + j) - *(r1 + j + 1);
		}

	for (j = 0; j <= 2; ++j)
		*(piz + j) = 0;

	*(piz + 3) = *(i1 + 2) - *(i1 + 3);

	for (j = 4; j <= (ln - 2); j += 2)
		{
			*(piz + j)     = *(i1 + j) + *(i1 + j + 1);
			*(piz + j + 1) = *(i1 + j) - *(i1 + j + 1);
		}

/*
 *	Zweitunterste Ebene der Faltung; "n = 2"
 */

	for (j = 0; j <= (ln - 4); j += 4)
		{
			*(r1 + j)     = *(prz + j)     + *(prz + j + 2);
			*(r1 + j + 1) = *(prz + j + 1) - *(piz + j + 3);
			*(r1 + j + 2) = *(prz + j)     - *(prz + j + 2);
			*(r1 + j + 3) = *(prz + j + 1) + *(piz + j + 3);
		}

	for (j = 0; j <= 3; ++j)
		*(i1 + j) = 0;

	for (j = 4; j <= (ln - 4); j += 4)
		{
			*(i1 + j)     = *(piz + j)     + *(piz + j + 2);
			*(i1 + j + 1) = *(piz + j + 1) + *(prz + j + 3);
			*(i1 + j + 2) = *(piz + j)     - *(piz + j + 2);
			*(i1 + j + 3) = *(piz + j + 1) - *(prz + j + 3);
		}

/*
 *	Restliche Faltungsebenen (ohne die letzte Faltungsebene); "n = 4 bis n = ln / 4"
 */

	if ((log2s & 1) == 0)
		ln2 = ln;
	else
		ln2 = ln >> 1;

	log2n = 2;

	for (n = 4; n <= (ln2 >> 3); n <<= 1, ++log2n)
		{
			diff = log2s - log2n;

			for (j = 0; j <= (ln >> (log2n + 1)) - 1; ++ j)
				{
					m = j << (log2n + 1);

					for (i = 0; i <= n >> 1; ++i)
						{
			 				k1 = ta[i << diff];
	 						l1 = ta[((n >> 1) + i) << diff];
							n1 = n + (m1 = i + m);
							*(prz + m1) = *(r1 + m1) + *(r1 + n1) * k1 + *(i1 + n1) * l1;
							*(piz + m1) = *(i1 + m1) + *(i1 + n1) * k1 - *(r1 + n1) * l1;
					 		*(prz + n1) = *(r1 + m1) - *(r1 + n1) * k1 - *(i1 + n1) * l1;
	 						*(piz + n1) = *(i1 + m1) - *(i1 + n1) * k1 + *(r1 + n1) * l1;
						}

					for (i = (n + 2) >> 1; i <= n - 1; ++i)
						{
							k1 = ta[i << diff];
	 						l1 = ta[(i - (n >> 1)) << diff];
							n1 = n + (m1 = i + m);
							*(prz + m1) = *(r1 + m1) + *(r1 + n1) * k1 - *(i1 + n1) * l1;
							*(piz + m1) = *(i1 + m1) + *(i1 + n1) * k1 + *(r1 + n1) * l1;
							*(prz + n1) = *(r1 + m1) - *(r1 + n1) * k1 + *(i1 + n1) * l1;
							*(piz + n1) = *(i1 + m1) - *(i1 + n1) * k1 - *(r1 + n1) * l1;
						}
				}

			n <<= 1;
			++log2n;
			--diff;

			for (j = 0; j <= (ln >> (log2n + 1)) - 1; ++ j)
				{
					m = j << (log2n + 1);

					for (i = 0; i <= n >> 1; ++i)
						{
			 				k1 = ta[i << diff];
	 						l1 = ta[((n >> 1) + i) << diff];
							n1 = n + (m1 = i + m);
							*(r1 + m1) = *(prz + m1) + *(prz + n1) * k1 + *(piz + n1) * l1;
							*(i1 + m1) = *(piz + m1) + *(piz + n1) * k1 - *(prz + n1) * l1;
					 		*(r1 + n1) = *(prz + m1) - *(prz + n1) * k1 - *(piz + n1) * l1;
	 						*(i1 + n1) = *(piz + m1) - *(piz + n1) * k1 + *(prz + n1) * l1;
						}

					for (i = (n + 2) >> 1; i <= n - 1; ++i)
						{
							k1 = ta[i << diff];
	 						l1 = ta[(i - (n >> 1)) << diff];
							n1 = n + (m1 = i + m);
							*(r1 + m1) = *(prz + m1) + *(prz + n1) * k1 - *(piz + n1) * l1;
							*(i1 + m1) = *(piz + m1) + *(piz + n1) * k1 + *(prz + n1) * l1;
							*(r1 + n1) = *(prz + m1) - *(prz + n1) * k1 + *(piz + n1) * l1;
							*(i1 + n1) = *(piz + m1) - *(piz + n1) * k1 - *(prz + n1) * l1;
						}
				}
		}

	if (ln2 == ln >> 1)
		{
			n = ln >> 2;
			log2n = log2s - 1;

			for (j = 0; j <= (ln >> (log2n + 1)) - 1; ++ j)
				{
					m = j << (log2n + 1);

					for (i = 0; i <= n >> 1; ++i)
						{
			 				k1 = ta[i << 1];
	 						l1 = ta[((n >> 1) + i) << 1];
							n1 = n + (m1 = i + m);
							*(prz + m1) = *(r1 + m1) + *(r1 + n1) * k1 + *(i1 + n1) * l1;
							*(piz + m1) = *(i1 + m1) + *(i1 + n1) * k1 - *(r1 + n1) * l1;
					 		*(prz + n1) = *(r1 + m1) - *(r1 + n1) * k1 - *(i1 + n1) * l1;
	 						*(piz + n1) = *(i1 + m1) - *(i1 + n1) * k1 + *(r1 + n1) * l1;
						}

					for (i = (n + 2) >> 1; i <= n - 1; ++i)
						{
							k1 = ta[i << 1];
	 						l1 = ta[(i - (n >> 1)) << 1];
							n1 = n + (m1 = i + m);
							*(prz + m1) = *(r1 + m1) + *(r1 + n1) * k1 - *(i1 + n1) * l1;
							*(piz + m1) = *(i1 + m1) + *(i1 + n1) * k1 + *(r1 + n1) * l1;
							*(prz + n1) = *(r1 + m1) - *(r1 + n1) * k1 + *(i1 + n1) * l1;
							*(piz + n1) = *(i1 + m1) - *(i1 + n1) * k1 - *(r1 + n1) * l1;
						}
				}
		}
	else
		for (i = 0; i <= ln - 1; ++i)
			{
				*(prz + i) = *(r1 + i);
				*(piz + i) = *(i1 + i);
			}

/*
 *	Letzte Faltungsebenen; "n = ln / 2"
 */

	n = ln >> 1;
	log2n = log2s;

	for (i = 0; i <= 2; ++i)
		{
			k1 = *(prz + (n1 = i + n)) * ta[i];
			l1 = *(piz + n1) * ta[((n >> 1) + i)];
			*(r1 + i)  = *(prz + i) + k1 + l1;
	 		*(r1 + n1) = *(prz + i) - k1 - l1;
		}

	for (i = 3; i <= n >> 1; ++i)
		{
			k1 = *(prz + (n1 = i + n)) * ta[i];
			l1 = *(piz + n1) * ta[((n >> 1) + i)];
			*(r1 + i)  = *(prz + i) + k1 + l1;
	 	}

	for (i = (n + 2) >> 1; i <= n - 1; ++i)
		{
			k1 = *(prz + (n1 = i + n)) * ta[i];
			l1 = *(piz + n1) * ta[(i - (n >> 1))];
			*(r1 + i) = *(prz + i) + k1 - l1;
		}

	return;
}

void multkurz(SHORT *z1, SHORT *z2, SHORT *produkt, SHORT cache, unsigned long l)

/*
 *	fft-Quadrierung krzerer Zahlen; Das ganze Drumrum
 *	Sehr kurze Zahlen werden nach multsehrkurz umgeleitet
 *		Eingabe:  *z1, *z2 (maximal stellen0 Stellen)
 *		Rckgabe: *produkt (Doppelt so viele Stellen wie z1)
 *		cache:    0, 1, 2 (Mglicherweise nur 1)
 *		l:        Stellenzahl von z1 (Doppelte Genauigkeit wird zurckgegeben)
 *	Falls l <= 8 wird konventionell multipliziert
 *	Falls l = "stellen" wird an die normale fft-Routine bergeben
 */

{
	double			zreal, zimag, ue;
	long			ln, i, index;
	unsigned long	uebertrag = 0;
	SHORT			diff;

	if (l < 16)
		{
			multsehrkurz(z1, z2, l, produkt);

			return;
		}

	if (l == (gstellen))
		{
			mult(z1, z2, produkt, cache);

			return;
		}

	ln = l << 1;
	diff = log2s2 - bas2log(ln);

	for (i = l; i <= stellen - 2; ++i)
		*(produkt + i) = 0;

	for (i = 0; i <= ln - 1; ++i)
		{
			*(i1 + i) = 0;
			*(i2 + i) = 0;
		}

	if (cache < 2)
		for (i = 0; i <= ln - 1; i += 2)
			{
				index = ba[i] >> diff;

				*(r1 + i)         = *(z1 + index);
				*(r1 + i + 1)     = *(z1 + index);
				*(r2 + i)         = *(z2 + index);
				*(r2 + i + 1)     = *(z2 + index);
			}
	else if (cache == 2)
		for (i = 0; i <= ln - 1; i += 2)
			{
				index = ba[i] >> diff;

				*(r1 + i)     = *(z1 + index);
				*(r1 + i + 1) = *(z1 + index);
			}
	else
		{
			for (i = 0; i <= ln - 1; i += 2)
				{
					index = ba[i] >> diff;

					*(r1 + i)     = *(z1 + index);
					*(r1 + i + 1) = *(z1 + index);
				}

			for (i = 0; i <= ln - 1; ++i)
				{
					*(r2 + i) = *(merkr + i);
					*(i2 + i) = *(merki + i);
				}
		}

	fftkurzhin(r1, i1, cache, 1, ln);

	if (cache < 2)
		fftkurzhin(r2, i2, 0, 1, ln);

	if ((cache == 1) || (cache == 3))
		for (i = 0; i <= ln - 1; ++i)
			{
				zreal = (*(merkr + i) * *(r2 + i)) - (*(merki + i) * *(i2 + i));
				zimag = (*(merkr + i) * *(i2 + i)) + (*(r2 + i) * *(merki + i));
				*(r2 + i) = zreal;
				*(i2 + i) = zimag;
			}
	else if (cache == 2)
		for (i = 0; i <= ln - 1; ++i)
			{
				zreal = (*(r1 + i) * *(merkr + i)) - (*(i1 + i) * *(merki + i));
				zimag = (*(r1 + i) * *(merki + i)) + (*(merkr + i) * *(i1 + i));
				*(r2 + i) = zreal;
				*(i2 + i) = zimag;
			}
	else
		for (i = 0; i <= ln - 1; ++i)
			{
				zreal = (*(r1 + i) * *(r2 + i)) - (*(i1 + i) * *(i2 + i));
				zimag = (*(r1 + i) * *(i2 + i)) + (*(r2 + i) * *(i1 + i));
				*(r2 + i) = zreal;
				*(i2 + i) = zimag;
			}

	for (i = 0; i <= ln - 1; ++i)
		{
			index = ba[i] >> diff;

			if (index > i)
				{
					*(r1 + i)     = *(r2 + index);
					*(i1 + i)     = *(i2 + index);
					*(r1 + index) = *(r2 + i);
					*(i1 + index) = *(i2 + i);
				}
			else if (index == i)
				{
					*(r1 + i) = *(r2 + i);
					*(i1 + i) = *(i2 + i);
				}
		}

	fftkurzrueck(r1, i1, 0, -1, ln);

/*
 *	Hier wird die kompliziertere bertrags-Auflsung
 *	durch eine Multiplikation mit 10 erreicht
 */

	for (i = l + 3; i >= l - 1; --i)
		{
			ue            = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag     = ue * 0.0001;
		}

	if ((ue - ((double) uebertrag * 10000)) >= 5000)
		++uebertrag;

	for (i = l - 2; i >= 0; --i)
		{
			ue                 = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag          = ue * 0.0001;
			*(produkt + i + 1) = ue - ((double) uebertrag * 10000);
		}

	*produkt = uebertrag;

	return;
}

void quadratkurz(SHORT *z1, SHORT *produkt, SHORT cache, unsigned long l)

/*
 *	fft-Quadrierung krzerer Zahlen; Das ganze Drumrum
 *	Sehr kurze Zahlen werden nach multsehrkurz umgeleitet
 *		Eingabe:  *z1 (maximal stellen0 Stellen)
 *		Rckgabe: *produkt (Doppelt so viele Stellen wie z1)
 *		cache:    0 oder 1 (Mglicherweise nur 1)
 *		l:        Stellenzahl von z1 (Doppelte Genauigkeit wird zurckgegeben
 *	Falls l <= 8 wird konventionell multipliziert
 *	Falls l = "stellen" wird an die normale fft-Routine bergeben
 */

{
	double			zreal, zimag, ue;
	long			ln, i, index;
	unsigned long	uebertrag = 0;
	SHORT			diff;

	if (l < 16)
		{
			multsehrkurz(z1, z1, l, produkt);

			return;
		}

	if (l == (gstellen))
		{
			quadrat(z1, produkt, cache);

			return;
		}

	ln = l << 1;
	diff = log2s2 - bas2log(ln);

	for (i = ln; i <= stellen - 2; ++i)
		*(produkt + i) = 0;

	if (cache < 2)
		{
			for (i = 0; i <= ln - 1; ++i)
				*(i1 + i) = 0;

			for (i = 0; i <= ln - 1; i += 2)
				{
					index = ba[i] >> diff;

					*(r1 + i)     = *(z1 + index);
					*(r1 + i + 1) = *(z1 + index);
				}

			fftkurzhin(r1, i1, cache, 1, ln);
		}

	if (cache == 2)
		{
			for (i = 0; i <= ln - 1; ++i)
				{
					zreal = (*(merkr + i) * *(merkr + i)) - (*(merki + i) * *(merki + i));
					zimag = 2 * *(merkr + i) * *(merki + i);
					*(r1 + i) = zreal;
					*(i1 + i) = zimag;
				}
		}
	else
		{
			for (i = 0; i <= ln - 1; ++i)
				{
					zreal = (*(r1 + i) * *(r1 + i)) - (*(i1 + i) * *(i1 + i));
					zimag = 2 * *(r1 + i) * *(i1 + i);
					*(r1 + i) = zreal;
					*(i1 + i) = zimag;
				}
		}

	for (i = 0; i <= ln - 1; ++i)
		{
			index = ba[i] >> diff;

			if (index > i)
				{
					zreal         = *(r1 + index);
					zimag         = *(i1 + index);
					*(r1 + index) = *(r1 + i);
					*(i1 + index) = *(i1 + i);
					*(r1 + i)     = zreal;
					*(i1 + i)     = zimag;
				}
		}

	fftkurzrueck(r1, i1, 0, -1, ln);

/*
 *	Hier wird die kompliziertere bertrags-Auflsung
 *	durch eine Multiplikation mit 10 erreicht
 */

	for (i = l + 3; i >= l - 1; --i)
		{
			ue            = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag     = ue * 0.0001;
		}

	if ((ue - ((double) uebertrag * 10000)) >= 5000)
		++uebertrag;

	for (i = l - 2; i >= 0; --i)
		{
			ue                 = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag          = ue * 0.0001;
			*(produkt + i + 1) = ue - ((double) uebertrag * 10000);
		}

	*produkt = uebertrag;

	return;
}

void fftkurzhin(double *r1, double *i1, SHORT cache, short int v, LONG ln)

/*
 *	Nicht-rekursive Fast Fourier Transformation
 *	Vorzeichen (v): +1 Hin; -1 Rck
 *	Lnge der Zahl: ln
 *	Die Zahl wird (hin: "geswapt") eingelesen und dann zurckgefaltet
 */

{
	double	k1, l1;
	long	i, j, m, n, m1, n1, n2;
	SHORT	log2n, diff;

	n2 = gstellen;

/*
 *	Zweitunterste Ebene der Faltung; "n = 2"
 */

	for (j = 0; j <= (ln - 4); j += 4)
		{
			*(prz + j)     =                    *(r1 + j) + *(r1 + j + 2);
			*(piz + j + 2) =   *(piz + j)     = 0;
			*(prz + j + 3) =   *(prz + j + 1) = *(r1 + j + 1) + *(i1 + j + 3);
			*(piz + j + 3) = -(*(piz + j + 1) = *(i1 + j + 1) - *(r1 + j + 3));
			*(prz + j + 2) =                    *(r1 + j) - *(r1 + j + 2);
		}

/*
 *	Drittunterste Faltungsebene; n = 4
 */

	for (j = 0; j <= (ln >> 3) - 1; ++j)
		{
			m = j << 3;
			*(r1 +     m) = *(prz + m) + *(prz + 4 + m);
	 		*(r1 + 4 + m) = *(prz + m) - *(prz + 4 + m);

			k1 = ta[gstellen >> 2];
			l1 = ta[(3 * gstellen) >> 2];
			*(r1 + 7 + m) =   *(r1 + 1 + m) = *(prz + 1 + m) + *(prz + 5 + m) * k1 - *(piz + 5 + m) * l1;
			*(i1 + 7 + m) = -(*(i1 + 1 + m) = *(piz + 1 + m) + *(piz + 5 + m) * k1 + *(prz + 5 + m) * l1);
	 		*(r1 + 3 + m) =   *(r1 + 5 + m) = *(prz + 1 + m) - *(prz + 5 + m) * k1 + *(piz + 5 + m) * l1;
			*(i1 + 3 + m) = -(*(i1 + 5 + m) = *(piz + 1 + m) - *(piz + 5 + m) * k1 - *(prz + 5 + m) * l1);
			*(r1 + 6 + m) =   *(r1 + 2 + m) = *(prz + 2 + m);
			*(i1 + 2 + m) = -(*(i1 + 6 + m) = *(prz + 6 + m));
		}

	for (i = 0; i <= ln - 1; ++i)
		{
			*(prz + i) = *(r1 + i);
			*(piz + i) = *(i1 + i);
		}

/*
 *	Restliche Faltungsebenen; "n = 8 bis n = ln"
 */

	log2n = 3;

	for (n = 8; n <= (ln >> 1); n <<= 1, ++log2n)
		{
			diff = log2s - log2n;

			for (j = 0; j <= (ln / (n << 1)) - 1; ++j)
				{
					m = j << (log2n + 1);

					for (i = 0; i <= n >> 1; ++i)
						{
			 				k1 = ta[i << diff];
	 						l1 = ta[((n >> 1) + i) << diff];
							n1 = n + (m1 = i + m);
							*(r1 + m1) = *(prz + m1) + *(prz + n1) * k1 - *(piz + n1) * l1;
							*(i1 + m1) = *(piz + m1) + *(piz + n1) * k1 + *(prz + n1) * l1;
					 		*(r1 + n1) = *(prz + m1) - *(prz + n1) * k1 + *(piz + n1) * l1;
	 						*(i1 + n1) = *(piz + m1) - *(piz + n1) * k1 - *(prz + n1) * l1;
						}

					for (i = (n + 2) >> 1; i <= n - 1; ++i)
						{
							k1 = ta[i << diff];
	 						l1 = ta[(i - (n >> 1)) << diff];
							n1 = n + (m1 = i + m);
							*(r1 + m1) = *(prz + m1) + *(prz + n1) * k1 + *(piz + n1) * l1;
							*(i1 + m1) = *(piz + m1) + *(piz + n1) * k1 - *(prz + n1) * l1;
							*(r1 + n1) = *(prz + m1) - *(prz + n1) * k1 - *(piz + n1) * l1;
							*(i1 + n1) = *(piz + m1) - *(piz + n1) * k1 + *(prz + n1) * l1;
						}
				}

			for (i = 0; i <= ln - 1; ++i)
				{
					*(prz + i) = *(r1 + i);
					*(piz + i) = *(i1 + i);
				}
		}

	if ((cache == 1) || (cache == 3))
			for (i = 0; i <= ln - 1; ++i)
				{
					*(merkr + i) = *(prz + i);
					*(merki + i) = *(piz + i);
				}

	return;
}

void fftkurzrueck(double *r1, double *i1, SHORT cache, short int v, LONG ln)

/*
 *	Nicht-rekursive Fast Fourier Transformation
 *	Vorzeichen (v): +1 Hin; -1 Rck
 *	Lnge der Zahl: ln
 *	Die Zahl wird (hin: "geswapt") eingelesen und dann zurckgefaltet
 */

{
	double	k1, l1;
	long	i, j, m, n, m1, n1, n2;
	SHORT	log2n, diff;

	n2 = gstellen;

/*
 *	Unterste Ebene der Faltung; "n = 1"
 */

	for (j = 0; j <= (ln - 2); j += 2)
		{
			*(prz + j)     = *(r1 + j) + *(r1 + j + 1);
			*(prz + j + 1) = *(r1 + j) - *(r1 + j + 1);
		}

	for (j = 0; j <= 2; ++j)
		*(piz + j) = 0;

	*(piz + 3) = *(i1 + 2) - *(i1 + 3);

	for (j = 4; j <= (ln - 2); j += 2)
		{
			*(piz + j)     = *(i1 + j) + *(i1 + j + 1);
			*(piz + j + 1) = *(i1 + j) - *(i1 + j + 1);
		}

	for (i = 0; i <= ln - 1; ++i)
		{
			*(r1 + i) = *(prz + i);
			*(i1 + i) = *(piz + i);
		}

/*
 *	Zweitunterste Ebene der Faltung; "n = 2"
 */

	for (j = 0; j <= (ln - 4); j += 4)
		{
			*(prz + j)     = *(r1 + j)     + *(r1 + j + 2);
			*(prz + j + 1) = *(r1 + j + 1) - *(i1 + j + 3);
			*(prz + j + 2) = *(r1 + j)     - *(r1 + j + 2);
			*(prz + j + 3) = *(r1 + j + 1) + *(i1 + j + 3);
		}

	for (j = 0; j <= 3; ++j)
		*(piz + j) = 0;

	for (j = 4; j <= (ln - 4); j += 4)
		{
			*(piz + j)     = *(i1 + j)     + *(i1 + j + 2);
			*(piz + j + 1) = *(i1 + j + 1) + *(r1 + j + 3);
			*(piz + j + 2) = *(i1 + j)     - *(i1 + j + 2);
			*(piz + j + 3) = *(i1 + j + 1) - *(r1 + j + 3);
		}

/*
 *	Restliche Faltungsebenen; "n = 4 bis n = ln"
 */

	log2n = 2;

	for (n = 4; n <= (ln >> 1); n <<= 1, ++log2n)
		{
			diff = log2s - log2n;

			for (j = 0; j <= (ln >> (log2n + 1)) - 1; ++j)
				{
					m = j << (log2n + 1);

					for (i = 0; i <= n >> 1; ++i)
						{
			 				k1 = ta[i << diff];
	 						l1 = ta[((n >> 1) + i) << diff];
							n1 = n + (m1 = i + m);
							*(r1 + m1) = *(prz + m1) + *(prz + n1) * k1 + *(piz + n1) * l1;
							*(i1 + m1) = *(piz + m1) + *(piz + n1) * k1 - *(prz + n1) * l1;
					 		*(r1 + n1) = *(prz + m1) - *(prz + n1) * k1 - *(piz + n1) * l1;
	 						*(i1 + n1) = *(piz + m1) - *(piz + n1) * k1 + *(prz + n1) * l1;
						}

					for (i = (n + 2) >> 1; i <= n - 1; ++i)
						{
							k1 = ta[i << diff];
	 						l1 = ta[(i - (n >> 1)) << diff];
							n1 = n + (m1 = i + m);
							*(r1 + m1) = *(prz + m1) + *(prz + n1) * k1 - *(piz + n1) * l1;
							*(i1 + m1) = *(piz + m1) + *(piz + n1) * k1 + *(prz + n1) * l1;
							*(r1 + n1) = *(prz + m1) - *(prz + n1) * k1 + *(piz + n1) * l1;
							*(i1 + n1) = *(piz + m1) - *(piz + n1) * k1 - *(prz + n1) * l1;
						}
				}

			for (i = 0; i <= ln - 1; ++i)
				{
					*(prz + i) = *(r1 + i);
					*(piz + i) = *(i1 + i);
				}
		}

	return;
}

void karatsuba(SHORT *m1, SHORT *m2, SHORT *produkt, LONG l)

/*
 *	Multipliziert nach dem Karatsuba-Mechanismus
 *	Anpassung der Ausgabe
 *	Da hier nur kurze Zahlen multipliziert werden, wird das Ergebnis ungerundet bernommen
 */

{
	int		zwischensumme, uebertrag = 0;
	long	i;

	for (i = (l << 1) - 1; i <= stellen - 2; ++i)
		*(produkt + l) = 0;

	kmult(m1, m2, produkt, l);

	for (i = (l << 1) - 1; i >= 0; --i)
		{
			zwischensumme = 10 * *(produkt + i) + uebertrag;
			uebertrag = zwischensumme / 10000;
			*(produkt + i) = zwischensumme - (10000 * uebertrag);
		}

	return;
}

void kmult(SHORT *m1, SHORT *m2, SHORT *prolang, int l)

/*
 *	Rekursive Karatsuba-Multiplikation
 */

{
	SHORT	*pm1l, *pm1r, *pm2l, *pm2r, *ps, *ps1, *pzprodukt;
	int		l1 = l / 2, i, vorzeichen = 1;
	LONG	p;

	if (l == 1)
		{
			p = *m1 * *m2;
			*prolang = p * 0.0001;
			*(prolang + 1) = p - (10000 * *prolang);

			return;
		}

	pm1l = m1;
	pm2l = m2;
	pm1r = (m1 + (l / 2));
	pm2r = (m2 + (l / 2));

	for (i = 0; i <= l - 1; ++i)
		*(prolang + i) = 0;

	ps		  = (SHORT *) malloc(l * sizeof(SHORT));
	ps1 	  = (SHORT *) malloc(l * sizeof(SHORT));
	pzprodukt = (SHORT *) malloc(l * sizeof(SHORT));

	kmult(pm1r, pm2r, pzprodukt, (l / 2));

	for (i = l - 1; i >= 0; --i)
		*(prolang + (i + l)) = *(pzprodukt + i);

	addier(prolang, pzprodukt, prolang, l / 2, l + (l / 2) + 1, l / 2);
	kmult(pm1l, pm2l, pzprodukt, l / 2);
	addier(prolang, pzprodukt, prolang, l / 2, l + (l / 2) + 1, l / 2);
	addier(prolang, pzprodukt, prolang, 0, l + 1, 0);

	if (subtrahier(pm1l, pm1r, ps1, 0, (l / 2) + 1, 0) == 1)
		{
			vorzeichen = -vorzeichen;
			subtrahier(pm1r, pm1l, ps1, 0, (l / 2) + 1, 0);
		}

	if (subtrahier(pm2r, pm2l, ps, 0, (l / 2) + 1, 0) == 1)
		{
			vorzeichen = -vorzeichen;
			subtrahier(pm2l, pm2r, ps, 0, (l / 2) + 1, 0);
		}

	kmult(ps, ps1, pzprodukt, l / 2);

	if (vorzeichen == 1)
		addier(prolang, pzprodukt, prolang, l / 2, l + (l / 2) + 1, l / 2);
	else
		subtrahier(prolang, pzprodukt, prolang, l / 2, l + (l / 2) + 1, l / 2);

		free(ps);
		free(ps1);
		free(pzprodukt);

		return;
	}

void multsehrkurz(SHORT *m1, SHORT *m2, int l, SHORT *produkt)

/*
 *	Multipliziert zwei kurze Zahlen und gibt das Produkt zurck
 *	ACHTUNG: RCKGABE in m1 oder m2 nicht mglich
 */

{
	LONG 	z, ue = 0;
	long 	i, j;
	div_t	qr;

	for (i = 0; i < 2 * l; ++i)
		*(produkt + i) = 0;

	if (l == 1)
		{
			z              = *m1 * *m2 * 10;
			*produkt       = z / 10000;
			*(produkt + 1) = z - (*produkt * 10000);

			return;
		}

	for (i = 0; i <= l - 1; ++i)
		{
			for (j = l - 1; j >= 0; --j)
				{
					z  = *(produkt + j + i + 1) + 10 * *(m1 + j) * *(m2 + i) + ue;
					qr = div(z, 10000);
					ue = qr.quot;
					*(produkt + j + i + 1) = qr.rem;
				}

			j = i;

			while (ue > 0)
				{
					z  = *(produkt + j) + ue;
					qr = div(z, 10000);
					ue = qr.quot;
					*(produkt + j) = qr.rem;
					--j;
				}
		}

	return;
}

void multganz(SHORT *zahl, int x, SHORT *produkt)

/*
 *	Multipliziert eine Zahl mit einer ganzen Zahl
 */

{
	int		z;
	SHORT	zp = 0;
	long	i;
	div_t	qr;

	for (i = gstellen; i >= 0; --i)
		{
			z              = (*(zahl + i) * x) + zp;
			qr             = div(z, 10000);
			zp             = qr.quot;
			*(produkt + i) = qr.rem;
		}

	return;
}

void kehrwert(SHORT *divisor, SHORT *zahl, int borwein)

/*
 *	Berechnet den Kehrwert von divisor und gibt ihn als zahl zurck
 *	Berechnung nach dem Verfahren von Newton
 *
 *	Falls borwein = 1:
 *
 *	Da hier vor allem bei hheren Borwein-Iterationen der Kehrwert von
 *		2.000 0000 0000 0000 ... berechnet werden, ist das Ergebnis nahe an
 *		0.499 9999 9999 9999 ...
 *	Die Anzahl der 0000 Stellen wird eingelesen, eine entsprechende Anzahl 9999 Stellen in Zahl wird vorweggenommen.
 *	la wird angepasst. beginn wird aber am Anfang nicht automatisch verdoppelt
 */

{
	long double		x0;
	long			nullen, beginn = 0, i, la = 4;

	nullen = zweikommanullen(divisor, stellen);

	if ((borwein == 1) && (nullen > 3))
		{
			*zahl = 499;

			for (i = 1; i <= nullen; ++i)
				*(zahl + i) = 9999;

			*(zahl + i) = 5000;
			la = basis(nullen) << 1;
		}
	else
		{
			x0          = 1E-3 * *divisor + 1E-7 * *(divisor + 1) + 1E-11 * *(divisor + 2) + 1E-15 * *(divisor + 3);
			x0          = 1 / x0;
			x0         *= 1000;
			*zahl       = x0;
			x0         -= *zahl;
			x0         *= 10000;
			*(zahl + 1) = x0;
			x0         -= *(zahl + 1);
			x0         *= 10000;
			*(zahl + 2) = x0;
			x0         -= *(zahl + 2);
			x0         *= 10000;
			*(zahl + 3) = x0;
		}

	multkurz(divisor, zahl, zhl2, 0, la);

	if (la < gstellen)
			la <<= 1;

	if (*zhl2 < 1000)
		{
			einsminusx(zhl2, x, la + 1);
			multkurz(zahl, x, zhl2, 0, la);
			beginn = fuehrendenullen(zhl2, beginn, stellen);
			addier(zahl, zhl2, zahl, beginn, la + 1, 0);
		}
	else
		{
			*zhl2 -= 1000;
			multkurz(zahl, zhl2, zhl2, 0, la);
			beginn = fuehrendenullen(zhl2, beginn, stellen);
			subtrahier(zahl, zhl2, zahl, beginn, la + 1, 0);
		}

	while (beginn < stellen0)
		{
			if (la < gstellen)
				la <<= 1;

			multkurz(zahl, divisor, zhl2, 1, la);

			if (*zhl2 < 1000)
				{
					einsminusx(zhl2, x, la + 1);
					multkurz(x, zahl, zhl2, 2, la);
					beginn = fuehrendenullen(zhl2, beginn, stellen);
					addier(zahl, zhl2, zahl, beginn, la + 1, 0);
				}
			else
				{
					*zhl2 -= 1000;
					multkurz(zhl2, zahl, zhl2, 2, la);
					beginn = fuehrendenullen(zhl2, beginn, stellen);
					subtrahier(zahl, zhl2, zahl, beginn, la + 1, 0);
				}
		}

	return;
}

void dividier(SHORT *dividend, SHORT *divisor, SHORT *quotient, int borwein)

/*
 *	Dividiert zwei Zahlen und gibt den Quotienten zurck
 *
 *	borwein = 1 falls die Division fr die Borwein-Formel genutzt wird. Siehe Kehwert-Routine
 */

{
	kehrwert(divisor, quotient, borwein);
	mult(dividend, quotient, quotient, 0);

	return;
}

void durchzwei(SHORT *zahl, SHORT *produkt, long ende)

/*
 *	Zahl durch 2 teilen
 */

{
	int 	fuenf = 0, zwischensumme, uebertrag = 1;
	long	i;

	for (i = ende - 1; i <= stellen - 2; ++i)
		*(produkt + i) = 0;

	for (i = 0; i <= ende - 2; ++i)
		{
			zwischensumme = *(zahl + i) >> 1;

			if (*(zahl + i) != zwischensumme << 1)
				{
					*(produkt + i) = zwischensumme + fuenf;
					fuenf = 5000;
				}
			else
				{
					*(produkt + i) = zwischensumme + fuenf;
					fuenf = 0;
				}
		}

	i = ende - 2;

	if (fuenf == 5000)
		{
			while (uebertrag == 1)
				{
					zwischensumme = *(produkt + i) + 1;
					uebertrag = 0;

					if (zwischensumme > 9999)
						{
							zwischensumme -= 10000;
							uebertrag = 1;
						}

					*(produkt + i) = zwischensumme;
					--i;
				}
		}

	return;
}

void durchvier(SHORT *zahl, SHORT *produkt, long anfang, long ende)

/*
 *	Zahl durch 4 teilen
 */

{
	long	i;
	float	zwischensumme, uebertrag = 0;

	for (i = 0; i <= anfang; ++i)
		*(produkt + i) = 0;

	for (i = ende - 1; i <= stellen - 2; ++i)
		*(produkt + i) = 0;

	for (i = anfang + 1; i <= ende - 2; ++i)
		{
			zwischensumme = (*(zahl + i) * 0.25) + uebertrag;
			*(produkt + i) = zwischensumme;
			uebertrag = 10000 * (zwischensumme - *(produkt + i));
		}

	return;
}

void wurzel(SHORT *wert, SHORT *produkt, SHORT anfangswert, long la)

/*
 *	Berechnet die Wurzel einer Zahl
 *	Falls anfangswert != 0 wird ber store ein Nherungswert eingelesen
 */

{
	long		beginn = 0;
	long double	x0;

	if (la > gstellen)
		la = gstellen;

	if (anfangswert == 0)
		{
			setznull(store);

			x0            = 1E-3 * *wert + 1E-7 * *(wert + 1) + 1E-11 * *(wert + 2) + 1E-15 * *(wert + 3);
			x0            = 1 / sqrt(x0);
			x0           *= 1000;
			*store       = x0;
			x0           -= *store;
			x0           *= 10000;
			*(store + 1) = x0;
			x0           -= *(store + 1);
			x0           *= 10000;
			*(store + 2) = x0;
			x0           -= *(store + 2);
			x0           *= 10000;
			*(store + 3) = x0;

			multsehrkurz(store, store, 4, zhl2);
		}
	else
		quadratkurz(store, zhl2, 0, la);

	if (la < gstellen)
		la <<= 1;

	multkurz(zhl2, wert, zhl2, 0, la);

	if (*zhl2 < 1000)
		{
			einsminusx(zhl2, zhl2, la + 1);
			durchzwei(zhl2, zhl2, la + 1);
			multkurz(store, zhl2, produkt, 0, la);
			beginn = fuehrendenullen(produkt, beginn, stellen);
			addier(store, produkt, store, beginn, la + 1, 0);
		}
	else
		{
			*zhl2 -= 1000;
			durchzwei(zhl2, produkt, la + 1);
			multkurz(store, produkt, produkt, 0, la);
			beginn = fuehrendenullen(produkt, beginn, stellen);
			subtrahier(store, produkt, store, beginn, la + 1, 0);
		}

	while (beginn < stellen0)
		{
			if (la < gstellen)
				la <<= 1;

			quadratkurz(store, zhl2, 1, la);
			multkurz(zhl2, wert, zhl2, 0, la);

			if (*zhl2 < 1000)
				{
					einsminusx(zhl2, zhl2, la + 1);
					durchzwei(zhl2, zhl2, la + 1);
					multkurz(zhl2, store, produkt, 2, la);
					beginn = fuehrendenullen(produkt, beginn, stellen);
					addier(store, produkt, store, beginn, la + 1, 0);
				}
			else
				{
					*zhl2 -= 1000;
					durchzwei(zhl2, zhl2, la + 1);
					multkurz(zhl2, store, produkt, 2, la);
					beginn = fuehrendenullen(produkt, beginn, stellen);
					subtrahier(store, produkt, store, beginn, la + 1, 0);
				}
		}

	mult(store, wert, produkt, 0);

	return;
}

void kubikwurzel(SHORT *wert, SHORT *zahl, SHORT inv)

/*
 *	inv = 1: Berechnet die Kubikwurzel einer Zahl (Nicht implementiert)
 *	inv = 2; Berechnet den Kehrwert der Kubikwurzel
 *
 *	Da hier vor allem bei hheren Borwein-Iterationen inverse Kubikwurzeln von
 *		0.999 9999 9999 9999 ... berechnet werden, ist das Ergebnis nahe an
 *		1.000 0000 0000 0000 ...
 *	Die Anzahl der 9999 Stellen wird eingelesen, eine entsprechende Anzahl 0000 Stellen in Zahl wird vorweggenommen.
 *	la wird angepasst. beginn wird aber am Anfang nicht automatisch verdoppelt
 */

{
	long		neunen, beginn = 0, la = 8;
	long double x0;

	setznull(zahl);

	neunen = fuehrendeneunen(wert, stellen);

	if (neunen > 3)
		{
			*zahl = 1000;
			*(zahl + neunen + 1) = 50;
			la = basis(neunen) << 1;

			quadratkurz(zahl, zhl2, 0, la);
			quadratkurz(zhl2, x, 0, la);
		}
	else
		{
			x0          = 1E-3 * *wert + 1E-7 * *(wert + 1) + 1E-11 * *(wert + 2) + 1E-15 * *(wert + 3);
			x0          = 1 / sqrt(sqrt(x0));
			x0         *= 1000;
			*zahl       = x0;
			x0         -= *zahl;
			x0         *= 10000;
			*(zahl + 1) = x0;
			x0         -= *(zahl + 1);
			x0         *= 10000;
			*(zahl + 2) = x0;
			x0         -= *(zahl + 2);
			x0         *= 10000;
			*(zahl + 3) = x0;

			multsehrkurz(zahl, zahl, 8, zhl2);
			multsehrkurz(zhl2, zhl2, 8, x);
		}

	if (la < gstellen)
			la <<= 1;

	multkurz(x, wert, x, 0, la);

	if (*x < 1000)
		{
			einsminusx(x, x, la + 1);
			durchvier(x, x, 0, la + 1);
			multkurz(x, zahl, x, 0, la);
			beginn = fuehrendenullen(x, beginn, stellen);
			addier(zahl, x, zahl, 0, la + 1, 0);
		}
	else
		{
			*x -= 1000;
			durchvier(x, x, 0, la + 1);
			multkurz(x, zahl, x, 0, la);
			beginn = fuehrendenullen(x, beginn, stellen);
			subtrahier(zahl, x, zahl, 0, la + 1, 0);
		}

	while (beginn < stellen0)
		{
			if (la < gstellen)
				la <<= 1;

			quadratkurz(zahl, x, 1, la);
			quadratkurz(x, x, 0, la);
			multkurz(wert, x, x, 0, la);

			if (*x < 1000)
				{
					einsminusx(x, x, la + 1);
					durchvier(x, x, 0, la + 1);
					multkurz(x, zahl, x, 2, la);
					beginn = fuehrendenullen(x, beginn, stellen);
					addier(zahl, x, zahl, 0, la + 1, 0);
				}
			else
				{
					*x -= 1000;
					durchvier(x, x, 0, la + 1);
					multkurz(x, zahl, x, 2, la);
					beginn = fuehrendenullen(x, beginn, stellen);
					subtrahier(zahl, x, zahl, 0, la + 1, 0);
				}
		}

	return;
}

void wurzel2(SHORT *produkt, SHORT inv)

/*
 *	Berechnet die Wurzel aus 2 falls inv = 1
 *	Berechnet 1 / Wurzel aus 2 falls inv = 2
 */

{
	long	beginn = 0, la = 8;

	 *x      = 707;
	*(x + 1) = 1067;
	*(x + 2) = 8118;
	*(x + 3) = 6547;
	*(x + 4) = 5244;
	*(x + 5) = 84;
	*(x + 6) = 4362;
	*(x + 7) = 1048;

	multsehrkurz(x, x, 8, zhl2);

	la <<= 1;

	nullfuenfminusx(zhl2, zhl2, la + 1);
	multkurz(x, zhl2, produkt, 0, la);
	beginn = fuehrendenullen(produkt, beginn, stellen);
	addier(x, produkt, x, beginn, la + 1, 0);

	while (beginn < stellen0)
		{
			if (la < gstellen)
				la <<= 1;

			quadratkurz(x, zhl2, 1, la);

			if (*zhl2 < 500)
				{
					nullfuenfminusx(zhl2, zhl2, la + 1);
					multkurz(zhl2, x, produkt, 2, la);
					beginn = fuehrendenullen(produkt, beginn, stellen);
					addier(x, produkt, x, beginn, la + 1, 0);
				}
			else
				{
					*zhl2 -= 500;
					multkurz(zhl2, x, produkt, 2, la);
					beginn = fuehrendenullen(produkt, beginn, stellen);
					subtrahier(x, produkt, x, beginn, la + 1, 0);
				}
		}

	if (inv == 1)
		multganz(x, 2, produkt);
	else
		zuweis (produkt, x, stellen);

	return;
}

void zuweis(SHORT *zahl1, SHORT *zahl2, long l)

/*
 *	Weist einer Zahl zahl1 der Lnge l den Wert der Zahl zahl2 zu.
 */

{
	long i;

	for (i = 0; i <= l - 2; ++i)
		*(zahl1 + i) = *(zahl2 + i);

	return;
}

void setznull(SHORT *zahl)

/*
 *	Setzt eine kurze Zahl gleich Null
 */

{
	long i;

	for (i = 0; i <= stellen - 2; ++i)
		*(zahl + i) = 0;

	return;
}

LONG fuehrendenullen(SHORT *zahl, long beginn, long l)

/*
 *	Ermittelt, wieviele fhrende Nullen	eine Zahl hat
 */

{
	long i = beginn;

	while ((*(zahl + i) == 0) && i <= (l - 1))
		++i;

	return(i);
}

LONG zweikommanullen(SHORT *zahl, long l)

/*
 *	Ermittelt, wieviele fhrende Nullen	eine Zahl hat nach einer fhrenden 2000
 */

{
	long i = 1;

	while ((*(zahl + i) == 0) && i <= (l - 1))
		++i;

	return(i - 1);
}

LONG fuehrendeneunen(SHORT *zahl, long l)

/*
 *	Ermittelt, wieviele fhrende Neunen	eine Zahl hat nach einer fhrenden 999
 */

{
	long	i = 1;

	while ((*(zahl + i) == 9999) && i <= (l - 1))
		++i;

	return(i - 1);
}

LONG nullenamende(SHORT *zahl)

/*
 *	Ermittelt, wieviele fhrende Nullen	eine Zahl hat
 */

{
	long	i = stellen - 2;

	while ((*(zahl + i) == 0) && i >= 0)
		--i;

	return(i + 1);
}

SHORT bas2log(LONG z)

/*
 *	Ermittelt von einer Potenz von 2 den Logarithmus zur Basis 2
 */

{
	SHORT	i = 0;

	while ((z & 1) != 1)
		{
			z >>= 1;
			++i;
		}

	return(i);
}

LONG basis(LONG z)

/*
 *	Ermittelt die nchste Potenz zur Basis 2
 */

{
	return(1 << (SHORT) ceil((SHORT) (1 / log10(2)) * log10(z)));
}

void bitswap(void)

/*
 *	Bit-Umkehr
 */

{
	LONG	i, zahl, wert;
	SHORT	j;

	for (zahl = 0; zahl <= stellen2 - 1; ++zahl)
		{
			wert = j = 0;

			for (i = 1; i <= gstellen; i <<= 1, ++j)
				if ((zahl & i) != 0)
					wert += (gstellen >> j);

			if (zahl < wert)
				{
					ba[wert] = zahl;
					ba[zahl] = wert;
				}
			else if (zahl == wert)
				ba[wert] = wert;
		}

	return;
}

LONG bs2(LONG zahl)

/*
 *	Bitswapping zur Basis 2
 */

{
	LONG	i, wert = 0;
	SHORT	j = 0;

	for (i = 1; i <= gstellen; i <<= 1, ++j)
		if ((zahl & i) != 0)
			wert += (gstellen >> j);

	return(wert);
}

LONG bs4(LONG zahl)

/*
 *	Bitswapping zur Basis 4
 */

{
	LONG i, wert = 0, zwischenwert;

	for (i = 3; i <= stellen2; i <<= 2)
		{
			zwischenwert = (zahl & i);
			wert += (zwischenwert * stellen2) / ((i / 3) * (i / 3) * 4);
		}

	return(wert);
}

void trigcalc(void)

/*
 *	trigonometric array: cos-werte von 0 bis pi
 */

{
	LONG	i;

 	ta[0] = 1;
	ta[stellen0 - 1] = 0;
	ta[stellen  - 1] = -1;

	for (i = 1; i <= stellen0 - 2; ++i)
		ta[gstellen - i] = -(ta[i] = cos(3.141592653589793238462643383279 * i / (gstellen)));

	return;
}

LONG eingabe()

/*
 *	Eingabe der zu berechnenden Stellen
 */

{
	char	z1, z2[10];
	LONG	st, z = 0, ganzzahl, mal = 1, mal2 = 1;
	SHORT	unkorrekt = 1;
	int		i, j;
	float	exponent, zahl;

	printf(" ******************************************************************************\n");
	printf(" **                              PiDig Version 1.2d                          **\n");
	printf(" **                    (http://www.digit-digger.purespace.de)                **\n");
	printf(" **                                   by JoPo                                **\n");
	printf(" ******************************************************************************\n\n");

/*
 *	Anzahl der Stellen
 */

	while (unkorrekt == 1)
		{
			printf("Number of decimal digits (Only powers of 2, e.g. 512, 4k, 512k, 1m): ");

			for (i = 0; (z1 = getchar()) != '\n'; i++)
				z2[i] = z1;

			--i;

			if ((z2[i] == 'k') || (z2[i] == 'K'))
				{
					mal = 1024;
					--i;
				}
			else if	((z2[i] == 'm') || (z2[i] == 'M'))
				{
					mal = 1048576;
					--i;
				}
			else if	((z2[i] == 'g') || (z2[i] == 'G'))
				{
					mal = 1073741824;
					--i;
				}

			for (j = i; j >= 0; --j)
				{
					z += ((z2[j] - 48) * mal2);
					mal2 *= 10;
				}

			z *= mal;

/*			if (z < 256)
				{
					printf("Program does not work for numbers smaller than 512\n");
					printf("Input is changed to 512\n");
					z = 256;
				}
			else
*/				unkorrekt = 0;
		}

	exponent = ((1 / log10(2)) * log10(z)) + 0.0001;
	ganzzahl = exponent;
	zahl = pow(2, ganzzahl);
	++ganzzahl;

	if (((zahl - z) < 1) && ((zahl - z) > -1))
		{
			st = z;
			printf("Input is %d\n", st);
		}
	else
		{
			st = pow(2, ganzzahl);
			printf("Only powers of 2 can be computed! Input is changed to %d\n", st);
		}

/*
 *	verwendete Formel
 */

	unkorrekt = 1;

	while (unkorrekt == 1)
		{
			printf("formula to use:  Borwein quartic (1)  Gauss AGM (2)  Sqrt[2] (8): ");
			scanf("%u6%*c\n", &z);

			if ((z == 9) || (z == 8) || (z < 3))
				unkorrekt = 0;
			else
				printf("value not valid\n");
		}

	formel = z;

 	return(st / 4);
}

void pformat(char *zahl)

/*
 *	Druckt kurze Zahl im Format:
 *	*.********** **********
 *	  ********** **********
 */

{
	int   i, zehn = 0, umbruch = 0, leerzeile = 0;
	float z;

	printf("%u", *zahl);
	printf(".\n");
	for (i = 1; i <= (2 * stellen2) - 1; ++i)
		{
			printf("%u", *(zahl + i));
			++zehn;

			if (zehn == 10)
				{
					printf(" ");
					++umbruch;
					zehn = 0;
				}

			if (umbruch == 5)
				{
					z = i;
					printf("     %6.0f\n", z);
					++leerzeile;
					umbruch = 0;
				}

			if (leerzeile == 10)
				leerzeile = 0;
		}

	printf("\n");
	printf("\n");

	return;
}

void infileplain(SHORT *zahl)

/*
 *	Kurze Zahl in Datei OUTPLAIN.TXT
 *  *********************************
 */

{
	FILE			*fp;
	unsigned long	i;
	char			wert;
	float			zahl1;

	fp = fopen("OUTPLAIN.TXT", "w");

	for (i = 0; i <= stellen - 2; ++i)
		{
			zahl1 = *(zahl + i) + 0.01;
/*MODUL*/
			wert = zahl1 * 0.001;
			fprintf(fp, "%u", wert);
			zahl1 -= (1000 * wert);

			wert = zahl1 * 0.01;
			fprintf(fp, "%u", wert);
			zahl1 -= (100 * wert);

			wert = zahl1 * 0.1;
			fprintf(fp, "%u", wert);
			zahl1 -= (10 * wert);

			wert = zahl1;
			fprintf(fp, "%u", wert);
		}

	fprintf(fp, "\n");
	fclose(fp);

	return;
}

SHORT infileformat(double zeit)

/*
 *	Speichert kurze Zahl im Format:
 *	*.
 *	********** **********
 *	********** **********
 */

{
	FILE	*fp, *fo;
	int		zehn = 0, umbruch = 0, leerzeile = 0;
	long	i;
	char	wert;
	float z;
	struct tm *newtime;
	time_t ltime;

	time (&ltime);
	newtime = localtime(&ltime);

	fp = fopen("OUTPLAIN.TXT", "r");

	if (fp == 0)
		{
			printf("aaaFehler");
			return(0);
		}

	fo = fopen("OUTFORM.TXT", "w");

	fprintf(fo, " ****************************************************************\n");
	fprintf(fo, " **                       PiDig Version 1.2d                   **\n");
	fprintf(fo, " **             (http://www.digit-digger.purespace.de)         **\n");
	fprintf(fo, " **                           von JoPo                         **\n");
	fprintf(fo, " ****************************************************************\n\n");

	if (formel != 8)
		fprintf(fo, " Calculation of pi to an accuracy of %d digits\n", 2 * stellen2);
	else
		fprintf(fo, " Calculation of sqrt(2) to an accuracy of %d digits\n", 2 * stellen2);

	if (formel == 1)
		fprintf(fo, " Method used: Borwein quartic argorithm\n");
	else if (formel == 2)
		fprintf(fo, " Method used: Gauss AGM argorithm\n");
	else if (formel == 3)
		fprintf(fo, " Method used: Gauss AGM, Variation by C. Bloodworth\n");

	if (vgl > 0)
		fprintf(fo, " Last %d digits are not correct\n", (2 * stellen2) - vgl);

	fprintf(fo, " Elapsed time: %.2f sec\n", zeit);
	fprintf(fo, " Calculated and stored: %s\n", asctime(newtime));

	wert = fgetc(fp) - 48;
	fprintf(fo, "%u.\n", wert);

	for (i = 1; i <= (2 * stellen2) - 1; ++i)
		{
			wert = fgetc(fp) - 48;
			fprintf(fo, "%u", wert);

			++zehn;

			if (zehn == 10)
				{
					fprintf(fo, " ");
					++umbruch;
					zehn = 0;
				}

			if (umbruch == 10)
				{
					z = i;
					fprintf(fo, "     %6.0f\n", z / 100);
					++leerzeile;
					umbruch = 0;
				}

			if (leerzeile == 10)
				{
					leerzeile = 0;
					fprintf(fo, "\n");
				}
		}

	fprintf(fo, "\n");

	fclose(fp);
	fclose(fo);

	return(1);
}

void einles(char *zahl)

/*
 *	Liest eine Zahl aus Datei OUTPLAIN.TXT ein
 *  *********************************
 */

{
	FILE	*fp;
	long	i;
	float	digit;

	fp = fopen("OUTPLAIN.TXT", "r");

	for (i = 0; i <= (2 * stellen2) - 1; ++i)
		{
			fscanf(fp, "%1f", &digit);
			*(zahl + i) = digit;
		}

	fclose(fp);

	return;
}

LONG vergleich()

/*
 *	Vergleicht Zahl mit dem Wert in PI.TXT
 *	(Format *****************)
 *	Rckgabe Zahl der falschen Stellen
 */

{
	FILE	*fp, *fo;
	int 	zehn = -1, umbruch = 0, leerzeile = 0, wert = 0, ungleich = 0;
	long	i;
	char	di, tu, falsch;

	fp = fopen("PI.TXT", "r");

	if (fp == 0)
		return(0);

	fo = fopen("OUTPLAIN.TXT", "r");

	for (i = 0; i <= (2 * stellen2) - 1; ++i)
		{
			di = fgetc(fp) - 48;
			tu = fgetc(fo) - 48;

			if (tu != di)
				{
					ungleich = 1;
					falsch = tu;
				}
			else
				{
					if (ungleich == 0)
						++wert;
				}
		}

	fclose(fp);
	fclose(fo);

	return(wert);
}

void pzahl(SHORT *zahl, SHORT a1, SHORT a2, LONG z1, LONG z2)

/*	Druck eine Zahl:
 *	a1	a2
 *	1			*.********** ********** ********** ********** **********	0
 *	2		ni	********************	0
 *	3		ni	*.********** ********** ********** ********** **********	0
 *	4		ni	*.********** ********** ********** ********** **********	0
 *	5   		von z1 bis z2 (Basis 10000)
 *		0		Ausgabe kontinuierlich
 *		1		Warten auf Tastendruck nach jeder Seite
 */

{
	LONG 		i, j = 0, k;
	div_t		qr;

	printf("\n");

	if (a1 < 5)
		{
			z1 = 0;
			z2 = stellen - 2;
		}
	else
		{
			j = z1 * 4;

			qr = div(j, 50);

			printf("  ");

			if (z1 > 11)
				printf(" ");

			for (k = 0; k <= qr.rem - 1; ++k)
				printf(" ");
		}

	for (i = z1; i <= z2 ; ++i)
		{
			qr = div(*(zahl + i), 1000);
			printf("%d", qr.quot);
			++j;
			uform(j, a1, a2);

			qr = div(qr.rem, 100);
			printf("%d", qr.quot);
			++j;
			uform(j, a1, a2);

			qr = div(qr.rem, 10);
			printf("%d", qr.quot);
			++j;
			uform(j, a1, a2);

			printf("%d", qr.rem);
			++j;
			uform(j, a1, a2);
		}

	qr = div(j, 50);

	for (k = 0; k <= (50 - qr.rem) * 1.1; ++k)
		printf(" ");

	printf("  %9d\n ", j - qr.rem);

	return;
}

void uform(LONG j1, SHORT a1, SHORT a2)

/*
 *	Hier werden Leerschlge, Umbrche u. . festgelegt
 */

{
	char	e = 0;
	div_t	ub;

	if (j1 == 1)
		printf(".");

	ub = div(j1, 10);

	if ((ub.rem == 0) && (j1 != 0))
		{
			printf(" ");

			ub = div(j1, 50);

			if ((ub.rem == 0) && (j1 != 0))
				{
					printf("  %9d\n ", j1 - 50);

					if (a2 == 1)
						{
							ub = div(j1, 2000);

							if ((ub.rem == 0) && (j1 != 0))
								while (e == 0)
									scanf("%s", e);
						}
				}
		}

	return;
}

void pcomplex(double *r1, double *i1, int n)

/*
 *	Druckt eine komplexe Zahlenfolge
 *	@ i@  @ i@  @ i@  @ i@
 *	Nur zur Wartungszwecken und zum Test
 */

{
	int i, j;

	j = 0;

	for (i = 0; i <= n - 1; ++i)
		{
			printf("%+9.0f", *(r1 + i));
			printf("%+5.0f", *(i1 + i));
			++j;

			if (j == 4)
				{
					printf("\n");
					j = 0;
				}
			else
				printf("; ");
		}

	printf("\n");

	if (j > 0)
		printf("\n");

	return;
}

void fft4(double *r1, double *i1, short vz, long ln)

{
	SHORT	ldm;
	long	m, mh, j, r, index;
	double	argument,
			ur0, ur1, ur2, ur3,
			ui0, ui1, ui2, ui3,
			tr0, tr1, tr2, tr3,
			ti0, ti1, ti2, ti3,
			zreal, zimag;

pcomplex(r1, i1, ln);

	for (ldm = (1 / log10(2)) * log10(ln); ldm >= 2; ldm -= 2)
	   {
			m = pow(2, ldm);
			mh = m / 4;

			for (j = 0; j <= mh - 1; ++j)
				{
					for (r = 0; r <= ln - 1; r += m)
						{
							ur0 = *(r1 + r + j);
							ui0 = *(i1 + r + j);
							ur1 = *(r1 + r + j + mh);
							ui1 = *(i1 + r + j + mh);
							ur2 = *(r1 + r + j + (2 * mh));
							ui2 = *(i1 + r + j + (2 * mh));
							ur3 = *(r1 + r + j + (3 * mh));
							ui3 = *(i1 + r + j + (3 * mh));

							tr0 = (ur0 + ur2) + (ur1 + ur3);
							ti0 = (ui0 + ui2) + (ui1 + ui3);
							tr2 = (ur0 + ur2) - (ur1 + ur3);
							ti2 = (ui0 + ui2) - (ui1 + ui3);
							tr1 = (ur0 - ur2) - vz * (ui1 - ui3);
							ti1 = (ui0 - ui2) + vz * (ur1 - ur3);
							tr3 = (ur0 - ur2) + vz * (ui1 - ui3);
							ti3 = (ui0 - ui2) - vz * (ur1 - ur3);

							argument = (vz * 2 * 3.141592653589793238462643383279 * j / m);
							tr1 = tr1 * cos(argument) - ti1 * sin(argument);
							ti1 = tr1 * sin(argument) + ti1 * cos(argument);
							argument *= 2;
							tr2 = tr2 * cos(argument) - ti2 * sin(argument);
							ti2 = tr2 * sin(argument) + ti2 * cos(argument);
							argument *= 1.5;
							tr3 = tr3 * cos(argument) - ti3 * sin(argument);
							ti3 = tr3 * sin(argument) + ti3 * cos(argument);

							zreal = tr1;
							zimag = ti1;
							tr1   = tr2;
							ti1   = ti2;
							tr2   = zreal;
							ti2   = zimag;

							*(r1 + r + j) = tr0;
							*(i1 + r + j) = ti0;
							*(r1 + r + j + mh) = tr1;
							*(i1 + r + j + mh) = ti1;
							*(r1 + r + j + (2 * mh)) = tr2;
							*(i1 + r + j + (2 * mh)) = ti2;
							*(r1 + r + j + (3 * mh)) = tr3;
							*(i1 + r + j + (3 * mh)) = ti3;
						}
				}
		}
pcomplex(r1, i1, ln);

	if ((ldm & 1) == 1)
		for (r = 0; r <= ln - 1; r += 2)
			{
				tr0 = *(r1 + r);
				tr1 = *(r1 + r + 1);
				ti0 = *(i1 + r);
				ti1 = *(i1 + r + 1);

				ur0 = tr0 + tr1;
				ur1 = tr0 - tr1;
				ui0 = ti0 + ti1;
				ui1 = ti0 - ti1;

				*(r1 + r)     = ur0;
				*(r1 + r + 1) = ur1;
				*(i1 + r)     = ui0;
				*(i1 + r + 1) = ui1;

			}

pcomplex(r1, i1, ln);
	for (j = 0; j <= ln - 1; ++j)
		if ((index = bs4(j)) > j)
			{
				zreal         = *(r1 + index);
				zimag         = *(i1 + index);
				*(r1 + index) = *(r1 + j);
				*(i1 + index) = *(i1 + j);
				*(r1 + j)     = zreal;
				*(i1 + j)     = zimag;
			}
pcomplex(r1, i1, ln);

stop
}

void m4 (SHORT *z1, SHORT *z2, SHORT *produkt)

{
	double			ue;
	long			n, ln, i;
	unsigned long	uebertrag = 0;

	 n = gstellen;
	ln = stellen2;

	for (i = 0; i <= n - 1; ++i)
		{
			*(r1 + i) = *(z1 + i);
			*(i1 + i) = 0;
		}

	for (i = n; i <= ln - 1; ++i);
		*(i1 + i) = *(r1 + i) = 0;

	fft4(r1, i1, 1, ln);

	fft4(r1, i1, -1, ln);

	for (i = n + 3; i >= n - 1; --i)
		{
			ue            = ((10 * ((*(r1 + i) / ln)) + 0.1) + uebertrag);
			uebertrag     = ue * 0.0001;
		}

	if ((ue - ((double) uebertrag * 10000)) >= 5000)
		++uebertrag;

	for (i = n - 2; i >= 0; --i)
		{
			ue                 = ((10 * ((*(r1 + i)/* / ln*/)) + 0.1) + uebertrag);
			uebertrag          = ue * 0.0001;
			*(produkt + i + 1) = ue - ((double) uebertrag * 10000);
		}

	*produkt = uebertrag;
	pzahl(produkt,1,0,0,0);

	return;
}

